"""
Database module for Bengali translations of emoji and emoticons.
Last Update: 04 September, 2020
"""

__all__ = ['EMO_UNICODE', 'UNICODE_EMO', 'EMOTICONS', 'EMOTICONS_EMO']

EMOTICONS = {
  ":‑\\)": "খুশি মুখ বা হাসিখুশি",
  ":\\)": "খুশি মুখ বা হাসিখুশি",
  ":-\\]": "খুশি মুখ বা হাসিখুশি",
  ":\\]": "খুশি মুখ বা হাসিখুশি",
  ":-3": "হাসি হাসি হাসি",
  ":3": "হাসি হাসি হাসি",
  ":->": "হাসি হাসি হাসি",
  ":>": "হাসি হাসি হাসি",
  "8-\\)": "হাসি হাসি হাসি",
  ":o\\)": "হাসি হাসি হাসি",
  ":-\\}": "হাসি হাসি হাসি",
  ":\\}": "হাসি হাসি হাসি",
  ":-\\)": "হাসি হাসি হাসি",
  ":c\\)": "হাসি হাসি হাসি",
  ":\\^\\)": "হাসি হাসি হাসি",
  "=\\]": "হাসি হাসি হাসি",
  "=\\)": "হাসি হাসি হাসি",
  ":‑D": "বড় হাসি হাসি বা চশমা সহ হাসি",
  ":D": "বড় হাসি হাসি বা চশমা সহ হাসি",
  "8‑D": "বড় হাসি হাসি বা চশমা সহ হাসি",
  "8D": "বড় হাসি হাসি বা চশমা সহ হাসি",
  "X‑D": "বড় হাসি হাসি বা চশমা সহ হাসি",
  "XD": "বড় হাসি হাসি বা চশমা সহ হাসি",
  "=D": "বড় হাসি হাসি বা চশমা সহ হাসি",
  "=3": "বড় হাসি হাসি বা চশমা সহ হাসি",
  "B\\^D": "বড় হাসি হাসি বা চশমা সহ হাসি",
  ":-\\)\\)": "খুব খুশি",
  ":‑\\(": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":-\\(": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":\\(": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":‑c": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":c": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":‑<": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":<": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":‑\\[": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":\\[": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":-\\|\\|": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ">:\\[": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":\\{": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":@": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ">:\\(": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":'‑\\(": "ক্রন্দিত",
  ":'\\(": "ক্রন্দিত",
  ":'‑\\)": "সুখের অশ্রু",
  ":'\\)": "সুখের অশ্রু",
  "D‑':": "ভয়াবহতা",
  "D:<": "বিতৃষ্ণা",
  "D:": "দুঃখ",
  "D8": "দুর্দান্ত হতাশাবোধ",
  "D;": "দুর্দান্ত হতাশাবোধ",
  "D=": "দুর্দান্ত হতাশাবোধ",
  "DX": "দুর্দান্ত হতাশাবোধ",
  ":‑O": "আশ্চর্য",
  ":O": "আশ্চর্য",
  ":‑o": "আশ্চর্য",
  ":o": "আশ্চর্য",
  ":-0": "শক",
  "8‑0": "হ্যাঁ",
  ">:O": "হ্যাঁ",
  ":-\\*": "চুমু",
  ":\\*": "চুমু",
  ":X": "চুমু",
  ";‑\\)": "পলক বা স্মার্ক",
  ";\\)": "পলক বা স্মার্ক",
  "\\*-\\)": "পলক বা স্মার্ক",
  "\\*\\)": "পলক বা স্মার্ক",
  ";‑\\]": "পলক বা স্মার্ক",
  ";\\]": "পলক বা স্মার্ক",
  ";\\^\\)": "পলক বা স্মার্ক",
  ":‑,": "পলক বা স্মার্ক",
  ";D": "পলক বা স্মার্ক",
  ":‑P": "জিহ্বা চটকদার কৌতুকপূর্ণ বা একটি রাস্পবেরি ফুঁকছে",
  ":P": "জিহ্বা চটকদার কৌতুকপূর্ণ বা একটি রাস্পবেরি ফুঁকছে",
  "X‑P": "জিহ্বা চটকদার কৌতুকপূর্ণ বা একটি রাস্পবেরি ফুঁকছে",
  "XP": "জিহ্বা চটকদার কৌতুকপূর্ণ বা একটি রাস্পবেরি ফুঁকছে",
  ":‑Þ": "জিহ্বা চটকদার কৌতুকপূর্ণ বা একটি রাস্পবেরি ফুঁকছে",
  ":Þ": "জিহ্বা চটকদার কৌতুকপূর্ণ বা একটি রাস্পবেরি ফুঁকছে",
  ":b": "জিহ্বা চটকদার কৌতুকপূর্ণ বা একটি রাস্পবেরি ফুঁকছে",
  "d:": "জিহ্বা চটকদার কৌতুকপূর্ণ বা একটি রাস্পবেরি ফুঁকছে",
  "=p": "জিহ্বা চটকদার কৌতুকপূর্ণ বা একটি রাস্পবেরি ফুঁকছে",
  ">:P": "জিহ্বা চটকদার কৌতুকপূর্ণ বা একটি রাস্পবেরি ফুঁকছে",
  ":‑/": "সংশয়ী বিরক্ত বিরক্তিহীন অস্বস্তি বা দ্বিধাগ্রস্ত",
  ":/": "সংশয়ী বিরক্ত বিরক্তিহীন অস্বস্তি বা দ্বিধাগ্রস্ত",
  ":-[.]": "সংশয়ী বিরক্ত বিরক্তিহীন অস্বস্তি বা দ্বিধাগ্রস্ত",
  ">:[(\\\\)]": "সংশয়ী বিরক্ত বিরক্তিহীন অস্বস্তি বা দ্বিধাগ্রস্ত",
  ">:/": "সংশয়ী বিরক্ত বিরক্তিহীন অস্বস্তি বা দ্বিধাগ্রস্ত",
  ":[(\\\\)]": "সংশয়ী বিরক্ত বিরক্তিহীন অস্বস্তি বা দ্বিধাগ্রস্ত",
  "=/": "সংশয়ী বিরক্ত বিরক্তিহীন অস্বস্তি বা দ্বিধাগ্রস্ত",
  "=[(\\\\)]": "সংশয়ী বিরক্ত বিরক্তিহীন অস্বস্তি বা দ্বিধাগ্রস্ত",
  ":L": "সংশয়ী বিরক্ত বিরক্তিহীন অস্বস্তি বা দ্বিধাগ্রস্ত",
  "=L": "সংশয়ী বিরক্ত বিরক্তিহীন অস্বস্তি বা দ্বিধাগ্রস্ত",
  ":S": "সংশয়ী বিরক্ত বিরক্তিহীন অস্বস্তি বা দ্বিধাগ্রস্ত",
  ":‑\\|": "সহজসরল চেহারা",
  ":\\|": "সহজসরল চেহারা",
  ":$": "বিব্রত",
  ":‑x": "সিলযুক্ত ঠোঁট বা ব্রেস বা জিহ্বা বাঁধা",
  ":x": "সিলযুক্ত ঠোঁট বা ব্রেস বা জিহ্বা বাঁধা",
  ":‑#": "সিলযুক্ত ঠোঁট বা ব্রেস বা জিহ্বা বাঁধা",
  ":#": "সিলযুক্ত ঠোঁট বা ব্রেস বা জিহ্বা বাঁধা",
  ":‑&": "সিলযুক্ত ঠোঁট বা ব্রেস বা জিহ্বা বাঁধা",
  ":&": "সিলযুক্ত ঠোঁট বা ব্রেস বা জিহ্বা বাঁধা",
  "O:‑\\)": "দেবদূত সাধু নাকি নির্দোষ",
  "O:\\)": "দেবদূত সাধু নাকি নির্দোষ",
  "0:‑3": "দেবদূত সাধু নাকি নির্দোষ",
  "0:3": "দেবদূত সাধু নাকি নির্দোষ",
  "0:‑\\)": "দেবদূত সাধু নাকি নির্দোষ",
  "0:\\)": "দেবদূত সাধু নাকি নির্দোষ",
  ":‑b": "জিহ্বা চটকদার কৌতুকপূর্ণ বা একটি রাস্পবেরি ফুঁকছে",
  "0;\\^\\)": "দেবদূত সাধু নাকি নির্দোষ",
  ">:‑\\)": "মন্দ বা শয়তান",
  ">:\\)": "মন্দ বা শয়তান",
  "\\}:‑\\)": "মন্দ বা শয়তান",
  "\\}:\\)": "মন্দ বা শয়তান",
  "3:‑\\)": "মন্দ বা শয়তান",
  "3:\\)": "মন্দ বা শয়তান",
  ">;\\)": "মন্দ বা শয়তান",
  "\\|;‑\\)": "শীতল",
  "\\|‑O": "উদাস",
  ":‑J": "গালে জিহ্বা",
  "#‑\\)": "সারারাত পার্টিতে",
  "%‑\\)": "মাতাল বা বিভ্রান্ত",
  "%\\)": "মাতাল বা বিভ্রান্ত",
  ":-###..": "অসুস্থ হচ্ছে",
  ":###..": "অসুস্থ হচ্ছে",
  "<:‑\\|": "ডাম্প",
  "\\(>_<\\)": "ঝামেলা",
  "\\(>_<\\)>": "ঝামেলা",
  "\\(';'\\)": "বাচ্চা",
  "\\(\\^\\^>``": "নার্ভাস বা বিব্রত বা ঝামেলা বা লজ্জাজনক বা ঘামের ড্রপ",
  "\\(\\^_\\^;\\)": "নার্ভাস বা বিব্রত বা ঝামেলা বা লজ্জাজনক বা ঘামের ড্রপ",
  "\\(-_-;\\)": "নার্ভাস বা বিব্রত বা ঝামেলা বা লজ্জাজনক বা ঘামের ড্রপ",
  "\\(~_~;\\) \\(・\\.・;\\)": "নার্ভাস বা বিব্রত বা ঝামেলা বা লজ্জাজনক বা ঘামের ড্রপ",
  "\\(-_-\\)zzz": "ঘুমাচ্ছে",
  "\\(\\^_-\\)": "পলক",
  "\\(\\(\\+_\\+\\)\\)": "বিভ্রান্ত",
  "\\(\\+o\\+\\)": "বিভ্রান্ত",
  "\\(o\\|o\\)": "আল্ট্রাম্যান",
  "\\^_\\^": "আনন্দময়",
  "\\(\\^_\\^\\)/": "আনন্দময়",
  "\\(\\^O\\^\\)／": "আনন্দময়",
  "\\(\\^o\\^\\)／": "আনন্দময়",
  "\\(__\\)": "ক্ষমা চাওয়ার জন্য সম্মান বা দোয়েজার চিহ্ন হিসাবে কোটা",
  "_\\(\\._\\.\\)_": "ক্ষমা চাওয়ার জন্য সম্মান বা দোয়েজার চিহ্ন হিসাবে কোটা",
  "<\\(_ _\\)>": "ক্ষমা চাওয়ার জন্য সম্মান বা দোয়েজার চিহ্ন হিসাবে কোটা",
  "<m\\(__\\)m>": "ক্ষমা চাওয়ার জন্য সম্মান বা দোয়েজার চিহ্ন হিসাবে কোটা",
  "m\\(__\\)m": "ক্ষমা চাওয়ার জন্য সম্মান বা দোয়েজার চিহ্ন হিসাবে কোটা",
  "m\\(_ _\\)m": "ক্ষমা চাওয়ার জন্য সম্মান বা দোয়েজার চিহ্ন হিসাবে কোটা",
  "\\('_'\\)": "দুঃখিত বা কাঁদছে",
  "\\(/_;\\)": "দুঃখিত বা কাঁদছে",
  "\\(T_T\\) \\(;_;\\)": "দুঃখিত বা কাঁদছে",
  "\\(;_;": "কান্নার দুঃখ",
  "\\(;_:\\)": "দু:খিত বা কাঁদছে",
  "\\(;O;\\)": "দুঃখিত বা কাঁদছে",
  "\\(:_;\\)": "দুঃখিত বা কাঁদছে",
  "\\(ToT\\)": "দুঃখিত বা কাঁদছে",
  ";_;": "দুঃখিত বা কাঁদছে",
  ";-;": "দুঃখিত বা কাঁদছে",
  ";n;": "দুঃখিত বা কাঁদছে",
  ";;": "দুঃখিত বা কাঁদছে",
  "Q\\.Q": "দুঃখিত বা কাঁদছে",
  "T\\.T": "দুঃখিত বা কাঁদছে",
  "QQ": "দুঃখিত বা কাঁদছে",
  "Q_Q": "দুঃখিত বা কাঁদছে",
  "\\(-\\.-\\)": "লজ্জা",
  "\\(-_-\\)": "লজ্জা",
  "\\(一一\\)": "লজ্জা",
  "\\(；一_一\\)": "লজ্জা",
  "\\(=_=\\)": "ক্লান্ত",
  "\\(=\\^\\·\\^=\\)": "বিড়াল",
  "\\(=\\^\\·\\·\\^=\\)": "বিড়াল",
  "=_\\^=\t": "বিড়াল",
  "\\(\\.\\.\\)": "নতমুখ",
  "\\(\\._\\.\\)": "নতমুখ",
  "\\^m\\^": "মুখ ঢাকা মুখ দিয়ে জিগলিং করছে",
  "\\(\\・\\・?": "বিভ্রান্তি",
  "\\(?_?\\)": "বিভ্রান্তি",
  ">\\^_\\^<": "সাধারণ হাসি",
  "<\\^!\\^>": "সাধারণ হাসি",
  "\\^/\\^": "সাধারণ হাসি",
  "\\（\\*\\^_\\^\\*）": "সাধারণ হাসি",
  "\\(\\^<\\^\\) \\(\\^\\.\\^\\)": "সাধারণ হাসি",
  "\\(^\\^\\)": "সাধারণ হাসি",
  "\\(\\^\\.\\^\\)": "সাধারণ হাসি",
  "\\(\\^_\\^\\.\\)": "সাধারণ হাসি",
  "\\(\\^_\\^\\)": "সাধারণ হাসি",
  "\\(\\^\\^\\)": "সাধারণ হাসি",
  "\\(\\^J\\^\\)": "সাধারণ হাসি",
  "\\(\\*\\^\\.\\^\\*\\)": "সাধারণ হাসি",
  "\\(\\^—\\^\\）": "সাধারণ হাসি",
  "\\(#\\^\\.\\^#\\)": "সাধারণ হাসি",
  "\\(\\*\\^0\\^\\*\\)": "উত্তেজিত",
  "\\(\\*_\\*\\)": "অবাক",
  "\\(\\*_\\*;": "অবাক",
  "\\(\\+_\\+\\) \\(@_@\\)": "অবাক",
  "\\(\\*\\^\\^\\)v": "হাসিখুশি হাসি",
  "\\(\\^_\\^\\)v": "হাসিখুশি হাসি",
  "\\(\\(d[-_-]b\\)\\)": "হেডফোন গান শুনছে",
  "\\(-\"-\\)": "চিন্তিত",
  "\\(ーー;\\)": "চিন্তিত",
  "\\(\\^0_0\\^\\)": "চশমা",
  "\\(\\＾ｖ\\＾\\)": "খুশি",
  "\\(\\＾ｕ\\＾\\)": "খুশি",
  "\\(\\^\\)o\\(\\^\\)": "খুশি",
  "\\(\\^O\\^\\)": "খুশি",
  "\\(\\^o\\^\\)": "খুশি",
  "\\)\\^o\\^\\(": "খুশি",
  ":O o_O": "অবাক",
  "o_0": "অবাক",
  "o\\.O": "অবাক",
  "\\(o\\.o\\)": "অবাক",
  "oO": "অবাক",
  "\\(\\*￣m￣\\)": "অসন্তুষ্ট",
  "🥇": "প্রথম স্থানের পদক",
  "🥈": "২য় স্থানের পদক",
  "🥉": "তৃতীয় স্থানের পদক",
  "🆎": "এবি বোতাম রক্তের ধরন",
  "🏧": "এটিএম সাইন",
  "🅰": "একটি বোতাম রক্তের ধরণ",
  "🇦 🇫": "আফগানিস্তান",
  "🇦 🇱": "আলবেনিয়া",
  "🇩 🇿": "আলজেরিয়া",
  "🇦 🇸": "আমেরিকান সামোয়া",
  "🇦 🇩": "আন্ডোরা",
  "🇦 🇴": "অ্যাঙ্গোলা",
  "🇦 🇮": "অ্যাঞ্জুইলা",
  "🇦 🇶": "অ্যান্টার্কটিকা",
  "🇦 🇬": "অ্যান্টিগুয়া বার্বুদা",
  "♒": "কুম্ভ",
  "🇦 🇷": "আর্জেন্টিনা",
  "♈": "মেষ",
  "🇦 🇲": "আর্মেনিয়া",
  "🇦 🇼": "আরুবা",
  "🇦 🇨": "অ্যাসেনশন দ্বীপ",
  "🇦 🇺": "অস্ট্রেলিয়া",
  "🇦 🇹": "অস্ট্রিয়া",
  "🇦 🇿": "আজারবাইজান",
  "🔙": "ফিরে তীর",
  "🅱": "বি বোতাম রক্তের প্রকার",
  "🇧 🇸": "বাহামা",
  "🇧 🇭": "বাহরাইন",
  "🇧 🇩": "বাংলাদেশ",
  "🇧 🇧": "বার্বাডোস",
  "🇧 🇾": "বেলারুশ",
  "🇧 🇪": "বেলজিয়াম",
  "🇧 🇿": "বেলিজ",
  "🇧 🇯": "বেনিন",
  "🇧 🇲": "বারমুডা",
  "🇧 🇹": "ভুটান",
  "🇧 🇴": "বলিভিয়া",
  "🇧 🇦": "বসনিয়া হার্জেগোভিনা",
  "🇧 🇼": "বোতসোয়ানা",
  "🇧 🇻": "বোভেট দ্বীপ",
  "🇧 🇷": "ব্রাজিল",
  "🇮 🇴": "ব্রিটিশ ভারত মহাসাগর অঞ্চল",
  "🇻 🇬": "ব্রিটিশ ভার্জিন দ্বীপপুঞ্জ",
  "🇧 🇳": "ব্রুনেই",
  "🇧 🇬": "বুলগেরিয়া",
  "🇧 🇫": "বুর্কিনা ফাসো",
  "🇧 🇮": "বুরুন্ডি",
  "🆑": "সিএল বোতাম",
  "🆒": "কুল বোতাম",
  "🇰 🇭": "কম্বোডিয়া",
  "🇨 🇲": "ক্যামেরুন",
  "🇨 🇦": "কানাডা",
  "🇮 🇨": "ক্যানারি দ্বীপপুঞ্জ",
  "♋": "কর্কট",
  "🇨 🇻": "কেপ ভার্দে",
  "♑": "মকর",
  "🇧 🇶": "ক্যারিবিয়ান নেদারল্যান্ডস",
  "🇰 🇾": "কেম্যান দ্বীপপুঞ্জ",
  "🇨 🇫": "মধ্য আফ্রিকান প্রজাতন্ত্র",
  "🇪 🇦": "সিউটা মেলিলা",
  "🇹 🇩": "চাদ",
  "🇨 🇱": "চিলি",
  "🇨 🇳": "চীন",
  "🇨 🇽": "ক্রিস্টমাস দ্বীপ",
  "🎄": "বড়দিনের গাছ",
  "🇨 🇵": "ক্লিপারটন দ্বীপ",
  "🇨 🇨": "কোকোস কিলিং দ্বীপপুঞ্জ",
  "🇨 🇴": "কলম্বিয়া",
  "🇰 🇲": "কোমোরোস",
  "🇨 🇬": "কঙ্গো ব্রাজাভিল",
  "🇨 🇩": "কঙ্গো কিনশা",
  "🇨 🇰": "কুক দ্বীপপুঞ্জ",
  "🇨 🇷": "কোস্টারিকা",
  "🇭 🇷": "ক্রোয়েশিয়া",
  "🇨 🇺": "কিউবা",
  "🇨 🇼": "কুরানাও",
  "🇨 🇾": "সাইপ্রাস",
  "🇨 🇿": "চেক প্রজাতন্ত্র",
  "🇨 🇮": "কোট ডি আইভায়ার",
  "🇩 🇰": "ডেনমার্ক",
  "🇩 🇬": "দিয়েগো গার্সিয়া",
  "🇩 🇯": "জিবুতি",
  "🇩 🇲": "ডোমিনিকা",
  "🇩 🇴": "ডোমিনিকান প্রজাতন্ত্র",
  "🔚": "শেষ তীর",
  "🇪 🇨": "ইকুয়েডর",
  "🇪 🇬": "মিশর",
  "🇸 🇻": "এল সালভাদর",
  "🇬 🇶": "নিরক্ষীয় গিনি",
  "🇪 🇷": "ইরিত্রিয়া",
  "🇪 🇪": "এস্তোনিয়া",
  "🇪 🇹": "ইথিওপিয়া",
  "🇪 🇺": "ইউরোপীয় ইউনিয়ন",
  "🆓": "বিনামূল্যে বোতাম",
  "🇫 🇰": "ফকল্যান্ড দ্বীপপুঞ্জ",
  "🇫 🇴": "ফারো দ্বীপপুঞ্জ",
  "🇫 🇯": "ফিজি",
  "🇫 🇮": "ফিনল্যান্ড",
  "🇫 🇷": "ফ্রান্স",
  "🇬 🇫": "একটি দেশের নাম",
  "🇵 🇫": "ফরাসি পলিনেশিয়া",
  "🇹 🇫": "ফরাসি সাউদার্ন টেরিটোরিজ",
  "🇬 🇦": "গাবন",
  "🇬 🇲": "গাম্বিয়া",
  "♊": "মিথুনরাশি",
  "🇬 🇪": "জর্জিয়া",
  "🇩 🇪": "জার্মানি",
  "🇬 🇭": "ঘানা",
  "🇬 🇮": "জিব্রাল্টার",
  "🇬 🇷": "গ্রীস",
  "🇬 🇱": "গ্রিনল্যান্ড",
  "🇬 🇩": "গ্রেনাডা",
  "🇬 🇵": "গুয়াদেলৌপ",
  "🇬 🇺": "গুয়াম",
  "🇬 🇹": "গুয়াতেমালা",
  "🇬 🇬": "গার্ন্সি",
  "🇬 🇳": "গিনি",
  "🇬 🇼": "গিনি বিসাউ",
  "🇬 🇾": "গিয়ানা",
  "🇭 🇹": "হাইতি",
  "🇭 🇲": "হার্ড ম্যাকডোনাল্ড দ্বীপপুঞ্জ",
  "🇭 🇳": "হন্ডুরাস",
  "🇭 🇰": "হংকং এসএআর চীন",
  "🇭 🇺": "হাঙ্গেরি",
  "🆔": "আইডি বোতাম",
  "🇮 🇸": "আইসল্যান্ড",
  "🇮 🇳": "ভারত",
  "🇮 🇩": "ইন্দোনেশিয়া",
  "🇮 🇷": "ইরান",
  "🇮 🇶": "ইরাক",
  "🇮 🇪": "আয়ারল্যান্ড",
  "🇮 🇲": "আইল অফ ম্যান",
  "🇮 🇱": "ইস্রায়েল",
  "🇮 🇹": "ইতালি",
  "🇯 🇲": "জামাইকা",
  "🇯 🇵": "জাপান",
  "🉑": "জাপানি গ্রহণযোগ্য বোতাম",
  "🈸": "জাপানি অ্যাপ্লিকেশন বোতাম",
  "🉐": "জাপানি দর কষাকষির বোতাম",
  "🏯": "জাপানি দুর্গ",
  "㊗": "জাপানি অভিনন্দন বোতাম",
  "🈹": "জাপানি ছাড় বাটন",
  "🎎": "জাপানি পুতুল",
  "🈚": "জাপানি বিনামূল্যে বাটন",
  "🈁": "জাপানি এখানে বোতাম",
  "🈷": "জাপানি মাসিক পরিমাণ বোতাম",
  "🈵": "জাপানিদের কোনও শূন্যপদ বাটন নেই",
  "🈶": "জাপানিরা নিখরচায় বোতাম না",
  "🈺": "জাপানিরা ব্যবসায়ের বোতামের জন্য উন্মুক্ত",
  "🈴": "জাপানি পাসিং গ্রেড বোতাম",
  "🏣": "জাপানি ডাকঘর",
  "🈲": "জাপানি নিষিদ্ধ বোতাম",
  "🈯": "জাপানি সংরক্ষিত বোতাম",
  "㊙": "জাপানি গোপন বোতাম",
  "🈂": "জাপানি পরিষেবা চার্জ বোতাম",
  "🔰": "শিক্ষানবিস জন্য জাপানি প্রতীক",
  "🈳": "জাপানি শূন্যস্থান বোতাম",
  "🇯 🇪": "জার্সি",
  "🇯 🇴": "জর্দান",
  "🇰 🇿": "কাজাখস্তান",
  "🇰 🇪": "কেনিয়া",
  "🇰 🇮": "কিরিবাতি",
  "🇽 🇰": "কসোভো",
  "🇰 🇼": "কুয়েত",
  "🇰 🇬": "কিরগিজস্তান",
  "🇱 🇦": "লাওস",
  "🇱 🇻": "লাটভিয়া",
  "🇱 🇧": "লেবানন",
  "♌": "লিও",
  "🇱 🇸": "লেসোথো",
  "🇱 🇷": "লাইবেরিয়া",
  "♎": "तुला",
  "🇱 🇾": "লিবিয়া",
  "🇱 🇮": "লিচেনস্টেইন",
  "🇱 🇹": "লিথুয়ানিয়া",
  "🇱 🇺": "লাক্সেমবার্গ",
  "🇲 🇴": "ম্যাকাও এসএআর চীন",
  "🇲 🇰": "ম্যাসিডোনিয়া",
  "🇲 🇬": "মাদাগাস্কার",
  "🇲 🇼": "মালাউই",
  "🇲 🇾": "মালয়েশিয়া",
  "🇲 🇻": "মালদ্বীপ",
  "🇲 🇱": "মালি",
  "🇲 🇹": "মাল্টা",
  "🇲 🇭": "মার্শাল দ্বীপপুঞ্জ",
  "🇲 🇶": "মার্টিনিক",
  "🇲 🇷": "মরিতানিয়া",
  "🇲 🇺": "মরিশাস",
  "🇾 🇹": "মায়োত্তে",
  "🇲 🇽": "মেক্সিকো",
  "🇫 🇲": "মাইক্রোনেশিয়া",
  "🇲 🇩": "মোল্দাভিয়া",
  "🇲 🇨": "মোনাকো",
  "🇲 🇳": "মঙ্গোলিয়া",
  "🇲 🇪": "মন্টিনিগ্রো",
  "🇲 🇸": "মন্টসারেট",
  "🇲 🇦": "মরক্কো",
  "🇲 🇿": "মোজাম্বিক",
  "🤶": "মিসেস ক্লজ",
  "🤶 🏿": "মিসেস ক্লজ",
  "🤶 🏻": "মিসেস ক্লজ",
  "🤶 🏾": "মিসেস ক্লজ",
  "🤶 🏼": "মিসেস ক্লজ",
  "🤶 🏽": "মিসেস ক্লজ",
  "🇲 🇲": "মায়ানমার (বার্মা",
  "🆕": "নতুন বোতাম",
  "🆖": "এনজি বাটন",
  "🇳 🇦": "নামিবিয়া",
  "🇳 🇷": "নাউরু",
  "🇳 🇵": "নেপাল",
  "🇳 🇱": "নেদারল্যান্ডস",
  "🇳 🇨": "নতুন ক্যালেডোনিয়া",
  "🇳 🇿": "নিউজিল্যান্ড",
  "🇳 🇮": "নিকারাগুয়া",
  "🇳 🇪": "নাইজার",
  "🇳 🇬": "নাইজেরিয়া",
  "🇳 🇺": "নিউ",
  "🇳 🇫": "নরফোক দ্বীপ",
  "🇰 🇵": "উত্তর কোরিয়া",
  "🇲 🇵": "উত্তর মারিয়ানা দ্বীপপুঞ্জ",
  "🇳 🇴": "নরওয়ে",
  "🆗": "ঠিক আছে বোতাম",
  "👌": "ঠিক আছে",
  "👌 🏻": "ঠিক আছে",
  "👌 🏾": "ঠিক আছে",
  "👌 🏼": "ঠিক আছে",
  "👌 🏽": "ঠিক আছে",
  "🔛": "তীর অন",
  "🅾": "ও বোতাম রক্তের প্রকার",
  "🇴 🇲": "ওমান",
  "🅿": "পি বোতাম",
  "🇵 🇰": "পাকিস্তান",
  "🇵 🇼": "পালাও",
  "🇵 🇸": "প্যালেস্তিনি অঞ্চল",
  "🇵 🇦": "পানামা",
  "🇵 🇬": "পাপুয়া নিউ গিনি",
  "🇵 🇾": "প্যারাগুয়ে",
  "🇵 🇪": "পেরু",
  "🇵 🇭": "ফিলিপিন্স",
  "♓": "মীন",
  "🇵 🇳": "পিটকার্ন দ্বীপপুঞ্জ",
  "🇵 🇱": "পোল্যান্ড",
  "🇵 🇹": "পর্তুগাল",
  "🇵 🇷": "পুয়ের্তো রিকো",
  "🇶 🇦": "কাতার",
  "🇷 🇴": "রোমানিয়া",
  "🇷 🇺": "রাশিয়া",
  "🇷 🇼": "রুয়ান্ডা",
  "🇷 🇪": "রিউনিয়ন",
  "🔜": "খুব তীর",
  "🆘": "এসওএস বোতাম",
  "♐": "ধনু",
  "🇼 🇸": "সামোয়া",
  "🇸 🇲": "সান মারিনো",
  "🎅": "সান্তা ক্লজ",
  "🎅 🏿": "সান্তা ক্লজ",
  "🎅 🏻": "সান্তা ক্লজ",
  "🎅 🏾": "সান্তা ক্লজ",
  "🎅 🏼": "সান্তা ক্লজ",
  "🎅 🏽": "সান্তা ক্লজ",
  "🇸 🇦": "সৌদি আরব",
  "♏": "বৃশ্চিক",
  "🇸 🇳": "সেনেগাল",
  "🇷 🇸": "সার্বিয়া",
  "🇸 🇨": "সেশেলস",
  "🇸 🇱": "সিয়েরা লিওন",
  "🇸 🇬": "সিঙ্গাপুর",
  "🇸 🇽": "সিন্ট মার্টেন",
  "🇸 🇰": "স্লোভাকিয়া",
  "🇸 🇮": "স্লোভেনিয়া",
  "🇸 🇧": "সলোমান দ্বীপপুঞ্জ",
  "🇸 🇴": "সোমালিয়া",
  "🇿 🇦": "দক্ষিন আফ্রিকা",
  "🇬 🇸": "দক্ষিণ জর্জিয়া দক্ষিণ স্যান্ডউইচ দ্বীপপুঞ্জ",
  "🇰 🇷": "দক্ষিণ কোরিয়া",
  "🇸 🇸": "দক্ষিণ সুদান",
  "🇪 🇸": "স্পেন",
  "🇱 🇰": "শ্রীলংকা",
  "🇧 🇱": "সেন্ট বার্থলেমি",
  "🇸 🇭": "সেন্ট হেলেনা",
  "🇰 🇳": "সেন্ট কিটস নেভিস",
  "🇱 🇨": "সেন্ট লুসিয়া",
  "🇲 🇫": "সেন্ট মার্টিন",
  "🇵 🇲": "সেন্ট পিয়ের মিকেলন",
  "🇻 🇨": "সেন্ট ভিনসেন্ট গ্রেনাডাইনস",
  "🗽": "স্ট্যাচু অফ লিবার্টি",
  "🇸 🇩": "সুদান",
  "🇸 🇷": "সুরিনাম",
  "🇸 🇯": "সোয়ালবার্ড জান মায়েন",
  "🇸 🇿": "সোয়াজিল্যান্ড",
  "🇸 🇪": "সুইডেন",
  "🇨 🇭": "সুইজারল্যান্ড",
  "🇸 🇾": "সিরিয়া",
  "🇸 🇹": "সাও তোমা প্রিনসিপে",
  "🔝": "শীর্ষ তীর",
  "🇹 🇼": "তাইওয়ান",
  "🇹 🇯": "তাজিকিস্তান",
  "🇹 🇿": "তানজানিয়া",
  "♉": "বৃষ",
  "🇹 🇭": "থাইল্যান্ড",
  "🇹 🇱": "টিমোর লেস্টে",
  "🇹 🇬": "যাও",
  "🇹 🇰": "টোকেলাউ",
  "🗼": "টোকিও মিনার",
  "🇹 🇴": "টঙ্গা",
  "🇹 🇹": "ত্রিনিদাদ ও টোবাগো",
  "🇹 🇦": "ত্রিস্তান দা কুনহা",
  "🇹 🇳": "তিউনিসিয়া",
  "🇹 🇷": "তুরস্ক",
  "🇹 🇲": "তুর্কমেনিস্তান",
  "🇹 🇨": "টার্ক কাইকোস দ্বীপপুঞ্জ",
  "🇹 🇻": "টুভালু",
  "🇺 🇲": "ইউ এস বহিরাগত দ্বীপপুঞ্জ",
  "🇻 🇮": "ইউ এস ভার্জিন দ্বীপপুঞ্জ",
  "🆙": "ইউপি বোতাম",
  "🇺 🇬": "উগান্ডা",
  "🇺 🇦": "ইউক্রেন",
  "🇦 🇪": "সংযুক্ত আরব আমিরাত",
  "🇬 🇧": "যুক্তরাজ্য",
  "🇺 🇳": "জাতিসংঘ",
  "🇺 🇸": "যুক্তরাষ্ট্র",
  "🇺 🇾": "উরুগুয়ে",
  "🇺 🇿": "উজবেকিস্তান",
  "🆚": "ভিএস বোতাম",
  "🇻 🇺": "ভানুয়াতু",
  "🇻 🇦": "ভ্যাটিকান সিটি",
  "🇻 🇪": "ভেনিজুয়েলা",
  "🇻 🇳": "ভিয়েতনাম",
  "♍": "কুমারী",
  "🇼 🇫": "ওয়ালিস ফুটুনা",
  "🇪 🇭": "পশ্চিম সাহারা",
  "🇾 🇪": "ইয়ামেন",
  "🇿 🇲": "জাম্বিয়া",
  "🇿 🇼": "জিম্বাবুয়ে",
  "🎟": "ভর্তি টিকিট",
  "🚡": "বিমান ট্রামওয়ে",
  "✈": "বিমান",
  "🛬": "বিমানের আগমন",
  "🛫": "বিমানের প্রস্থান",
  "⏰": "অ্যালার্মঘড়ি",
  "⚗": "আলেম্বিক",
  "👽": "পরক",
  "👾": "এলিয়েন দানব",
  "🚑": "অ্যাম্বুলেন্স",
  "🏈": "আমেরিকান ফুটবল",
  "🏺": "অ্যাম্ফোরা",
  "⚓": "নোঙ্গর",
  "💢": "রাগ প্রতীক",
  "😠": "রাগান্বিত মুখমন্ডল",
  "👿": "শিংয়ের সাথে রাগান্বিত মুখ",
  "😧": "দুঃখিত মুখ",
  "🐜": "পিপড়া",
  "📶": "অ্যান্টেনা বার",
  "🔄": "অ্যান্টল্লকওয়াইসের তীর বোতাম",
  "🚛": "জড়িত লরি",
  "🎨": "শিল্পী প্যালেট",
  "😲": "অবাক মুখ",
  "⚛": "পরমাণু প্রতীক",
  "🚗": "অটোমোবাইল",
  "🥑": "অ্যাভোকাডো",
  "👶": "বাচ্চা",
  "👼": "শিশুর দেবদূত",
  "👼 🏿": "শিশুর দেবদূত",
  "👼 🏻": "শিশুর দেবদূত",
  "👼 🏾": "শিশুর দেবদূত",
  "👼 🏼": "শিশুর দেবদূত",
  "👼 🏽": "শিশুর দেবদূত",
  "🍼": "শিশুর বোতল",
  "🐤": "ছোট্ট ছানা",
  "👶 🏿": "শিশু",
  "👶 🏻": "শিশু",
  "👶 🏾": "শিশু",
  "👶 🏼": "শিশু",
  "👶 🏽": "শিশু",
  "🚼": "শিশুর প্রতীক",
  "👇": "ব্যাকহ্যান্ড সূচক নীচে ইশারা",
  "👇 🏿": "নির্দেশ করে ব্যাকহ্যান্ড সূচক",
  "👇 🏻": "ব্যাকহ্যান্ড সূচক",
  "👇 🏾": "ব্যাকহ্যান্ড সূচক",
  "👇 🏼": "ব্যাকহ্যান্ড সূচক",
  "👇 🏽": "ব্যাকহ্যান্ড সূচক",
  "👈": "ব্যাকহ্যান্ড সূচক বাম দিকে নির্দেশ করছে",
  "👈 🏿": "ব্যাকহ্যান্ড সূচক বাম নির্দেশ করে",
  "👈 🏻": "ব্যাকহ্যান্ড সূচক বাম নির্দেশ করে",
  "👈 🏾": "বেকহ্যান্ড সূচক বাম নির্দেশ করছে",
  "👈 🏼": "ব্যাকহ্যান্ড সূচক বাম নির্দেশ করে",
  "👈 🏽": "ব্যাকহ্যান্ড সূচক বাম নির্দেশ করে",
  "👉": "ব্যাকহ্যান্ড সূচক ডানদিকে নির্দেশ করছে",
  "👉 🏿": "ডান নির্দেশ করে ব্যাকহ্যান্ড সূচক",
  "👉 🏻": "ডান নির্দেশ করে ব্যাকহ্যান্ড সূচক",
  "👉 🏾": "ডান নির্দেশ করে ব্যাকহ্যান্ড সূচক",
  "👉 🏼": "ডান নির্দেশ করে ব্যাকহ্যান্ড সূচক",
  "👉 🏽": "ডান নির্দেশ করে ব্যাকহ্যান্ড সূচক",
  "👆": "ব্যাকহ্যান্ড সূচক পয়েন্ট আপ",
  "👆 🏿": "নির্দেশ করে ব্যাকহ্যান্ড সূচক",
  "👆 🏻": "ব্যাকহ্যান্ড সূচক নির্দেশ করে",
  "👆 🏾": "নির্দেশ করে ব্যাকহ্যান্ড সূচক",
  "👆 🏼": "নির্দেশ করে ব্যাকহ্যান্ড সূচক",
  "👆 🏽": "নির্দেশ করে ব্যাকহ্যান্ড সূচক",
  "🥓": "বেকন",
  "🏸": "ব্যাডমিন্টন",
  "🛄": "লাগেজ দাবি",
  "🥖": "ব্যাগুয়েট রুটি",
  "⚖": "ব্যালেন্স স্কেল",
  "🎈": "বেলুন",
  "🗳": "ব্যালট সহ ব্যালট বাক্স",
  "☑": "চেক সহ ব্যালট বাক্স",
  "🍌": "কলা",
  "🏦": "ব্যাংক",
  "📊": "বার চার্ট",
  "💈": "নাপিত খুঁটি",
  "⚾": "বেসবল",
  "🏀": "বাস্কেটবল",
  "🦇": "ব্যাট",
  "🛁": "বাথটাব",
  "🔋": "ব্যাটারি",
  "🏖": "ছাতা সঙ্গে সৈকত",
  "🐻": "ভাল্লুক মুখ",
  "💓": "স্পন্দিত হৃদয়",
  "🛏": "বিছানা",
  "🍺": "বিয়ার মগ",
  "🔔": "বেল",
  "🔕": "স্ল্যাশ সহ ঘণ্টা",
  "🛎": "বেলহপ বেল",
  "🍱": "বেন্টো বাক্স",
  "🚲": "সাইকেল",
  "👙": "বিকিনি",
  "☣": "বায়োহাজার্ড",
  "🐦": "পাখি",
  "🎂": "জন্মদিনের কেক",
  "⚫": "কালো বৃত্ত",
  "🏴": "কালো পতাকা",
  "🖤": "কালো হৃদয়",
  "⬛": "কালো বড় বর্গাকার",
  "◾": "কালো ছোট বর্গক্ষেত্র",
  "◼": "কালো বর্গ",
  "✒": "কালো নিব",
  "▪": "কালো ছোট বর্গ",
  "🔲": "কালো বর্গাকার বোতাম",
  "👱 ‍ ♂ ️": "স্বর্ণকেশী কেশিক মানুষ",
  "👱 🏿 ‍ ♂ ️": "স্বর্ণকেশী কেশিক মানুষ",
  "👱 🏻 ‍ ♂ ️": "স্বর্ণকেশী লোমশ মানুষ",
  "👱 🏾 ‍ ♂ ️": "স্বর্ণকেশী কেশিক মানুষ",
  "👱 🏼 ‍ ♂ ️": "স্বর্ণকেশী কেশিক মানুষ",
  "👱 🏽 ‍ ♂ ️": "স্বর্ণকেশী কেশিক মানুষ",
  "👱": "স্বর্ণকেশী কেশিক ব্যক্তি",
  "👱 🏿": "স্বর্ণকেশী কেশিক ব্যক্তি",
  "👱 🏻": "স্বর্ণকেশী কেশিক ব্যক্তি",
  "👱 🏾": "স্বর্ণকেশী কেশিক ব্যক্তি",
  "👱 🏼": "স্বর্ণকেশী কেশিক ব্যক্তি",
  "👱 🏽": "স্বর্ণকেশী কেশিক ব্যক্তি",
  "👱 ‍ ♀ ️": "স্বর্ণকেশী কেশিক মহিলা",
  "👱 🏿 ‍ ♀ ️": "স্বর্ণকেশী কেশিক মহিলা",
  "👱 🏻 ‍ ♀ ️": "স্বর্ণকেশী কেশিক মহিলা",
  "👱 🏾 ‍ ♀ ️": "স্বর্ণকেশী কেশিক মহিলা",
  "👱 🏼 ‍ ♀ ️": "স্বর্ণকেশী কেশিক মহিলা",
  "👱 🏽 ‍ ♀ ️": "স্বর্ণকেশী কেশিক মহিলা",
  "🌼": "পুষ্প",
  "🐡": "ব্লোফিশ",
  "📘": "নীল বই",
  "🔵": "নীল বৃত্ত",
  "💙": "নীল হৃদয়",
  "🐗": "শুয়োর",
  "💣": "বোমা",
  "🔖": "বুকমার্ক",
  "📑": "বুকমার্ক ট্যাব",
  "📚": "বই",
  "🍾": "পপিং কর্ক দিয়ে বোতল",
  "💐": "তোড়া",
  "🏹": "তীর - ধনুক",
  "🎳": "বোলিং",
  "🥊": "মুষ্টি যুদ্ধের দস্তানা",
  "👦": "ছেলে",
  "👦 🏿": "ছেলে",
  "👦 🏻": "ছেলে",
  "👦 🏾": "ছেলে",
  "👦 🏼": "ছেলে",
  "👦 🏽": "ছেলি",
  "🍞": "রুটি",
  "👰": "পর্দা সঙ্গে কনে",
  "👰 🏿": "ওড়না সঙ্গে কনে",
  "👰 🏻": "ওড়না সঙ্গে কনে",
  "👰 🏾": "ওড়না সঙ্গে কনে",
  "👰 🏼": "ওড়না সঙ্গে কনে",
  "👰 🏽": "ওড়না সঙ্গে কনে",
  "🌉": "রাতে ব্রিজ",
  "💼": "ব্রিফকেস",
  "🔆": "উজ্জ্বল বোতাম",
  "💔": "ভাঙ্গা মন",
  "🐛": "বাগ",
  "🏗": "ভবন নির্মান",
  "🌯": "বুরিটো",
  "🚌": "বাস",
  "🚏": "বাস স্টপ",
  "👤": "সিলুয়েটে আবক্ষ",
  "🦋": "প্রজাপতি",
  "🌵": "ক্যাকটাস",
  "📅": "পঞ্জিকা",
  "🤙": "আমাকে ফোন কর",
  "🐪": "উট",
  "📷": "ক্যামেরা",
  "📸": "ফ্ল্যাশ সহ ক্যামেরা",
  "🏕": "শিবির",
  "🕯": "মোমবাতি",
  "🍬": "মিছরি",
  "🛶": "ক্যানো",
  "🗃": "কার্ড ফাইল বাক্স",
  "📇": "কার্ড সূচি",
  "🗂": "কার্ড সূচক বিভাজক",
  "🎠": "ক্যারোসেল ঘোড়া",
  "🎏": "কার্প স্ট্রিমার",
  "🥕": "গাজর",
  "🏰": "দুর্গ",
  "🐈": "বিড়াল",
  "🐱": "বিড়াল মুখ",
  "😹": "আনন্দের অশ্রু সহ বিড়াল মুখ",
  "😼": "বিড়াল হাসি সঙ্গে বিড়াল মুখ",
  "⛓": "চেইন",
  "📉": "চার্ট হ্রাস হচ্ছে",
  "📈": "চার্ট বাড়ছে",
  "💹": "ইয়েন দিয়ে চার্ট বাড়ছে",
  "🧀": "পনির কীলক",
  "🏁": "চেকড পতাকা",
  "🍒": "চেরি",
  "🌸": "চেরি পুষ্প",
  "🌰": "বুকে",
  "🐔": "মুরগি",
  "🚸": "শিশুদের পারাপার",
  "🐿": "চিপমুন্ক",
  "🍫": "চকলেট বার",
  "⛪": "গির্জা",
  "🚬": "সিগারেট",
  "🎦": "সিনেমা",
  "Ⓜ": "বৃত্তাকার এম",
  "🎪": "সার্কাসের তাঁবু",
  "🏙": "নগরী",
  "🌆": "সন্ধ্যার দিকে নগরীর দৃশ্য",
  "🗜": "বাতা",
  "🎬": "তালি বোর্ড",
  "👏": "হাততালি",
  "👏 🏿": "হাততালি হাত",
  "👏 🏻": "হাততালি",
  "👏 🏾": "হাততালি",
  "👏 🏼": "হাততালি",
  "👏 🏽": "হাততালি",
  "🏛": "ধ্রুপদী ভবন",
  "🍻": "ক্লিয়ারিং বিয়ার মগস",
  "🥂": "ক্লিংকিং চশমা",
  "📋": "ক্লিপবোর্ড",
  "🔃": "ঘড়ির কাঁটার দিকের উল্লম্ব তীরগুলি",
  "📕": "বন্ধ বই",
  "📪": "নিম্ন পতাকা সহ বন্ধ মেলবক্স",
  "📫": "উত্থিত পতাকা সহ বন্ধ মেলবক্স",
  "🌂": "বন্ধ ছাতা",
  "☁": "মেঘ",
  "🌩": "বজ্রপাত সহ মেঘ",
  "⛈": "বাজ এবং বৃষ্টি সঙ্গে মেঘ",
  "🌧": "বৃষ্টি সহ মেঘ",
  "🌨": "তুষার সহ মেঘ",
  "🤡": "ভাঁড় মুখ",
  "♣": "ক্লাব মামলা",
  "👝": "ছোঁ ব্যাগ",
  "🍸": "ককটেল গ্লাস",
  "⚰": "শবাধার",
  "💥": "সংঘর্ষ",
  "☄": "ধূমকেতু",
  "💽": "কম্পিউটার ডিস্ক",
  "🖱": "কম্পিউটার মাউস",
  "🎊": "কনফিটি বল",
  "😖": "বিব্রত মুখ",
  "😕": "বিভ্রান্ত মুখ",
  "🚧": "নির্মাণ",
  "👷": "নির্মাণ শ্রমিক",
  "👷 🏿": "নির্মাণ শ্রমিক",
  "👷 🏻": "নির্মাণ কর্মী",
  "👷 🏾": "নির্মাণ শ্রমিক",
  "👷 🏼": "নির্মাণ শ্রমিক",
  "👷 🏽": "নির্মাণ শ্রমিক",
  "🎛": "কড়া নিয়ন্ত্রণ",
  "🏪": "সুবিধার দোকান",
  "🍚": "রান্না করা ভাত",
  "🍪": "কুকি",
  "🍳": "রান্না",
  "©": "কপিরাইট",
  "🛋": "পালঙ্ক এবং বাতি",
  "💑": "হৃদয় সঙ্গে দম্পতি",
  "👨 ‍ ❤ ️ ‍ 👨": "হার্ট ম্যান ম্যান সাথে দম্পতি",
  "👩 ‍ ❤ ️ ‍ 👨": "হার্ট মহিলা পুরুষের সাথে দম্পতি",
  "👩 ‍ ❤ ️ ‍ 👩": "হার্ট মহিলা মহিলার সাথে দম্পতি",
  "🐄": "গাভী",
  "🐮": "গরুর মুখ",
  "🤠": "কাউবয় টুপি মুখ",
  "🦀": "কাঁকড়া",
  "🖍": "ক্রাইওন",
  "💳": "ক্রেডিট কার্ড",
  "🌙": "অর্ধচন্দ্র",
  "🏏": "ক্রিকেট",
  "🐊": "কুম্ভীর",
  "🥐": "ক্রোস্যান্ট",
  "❌": "কাটা চিহ্ন",
  "❎": "ক্রস চিহ্ন বোতাম",
  "🤞": "আঙ্গুলের ক্রস",
  "🤞 🏿": "অন্ধকার আঙ্গুলগুলি",
  "🤞 🏻": "আঙ্গুলের",
  "🤞 🏾": "আঙ্গুলের",
  "🤞 🏼": "আঙ্গুলের",
  "🤞 🏽": "আঙ্গুললি ছাড়িয়ে গেছে",
  "🎌": "ক্রস পতাকা",
  "⚔": "অতিক্রম তরোয়াল",
  "👑": "মুকুট",
  "😿": "কান্না বিড়াল মুখ",
  "😢": "কান্নাকাটি",
  "🔮": "ক্রিস্টাল বল",
  "🥒": "শসা",
  "➰": "কোঁকড়া লুপ",
  "💱": "মুদ্রা বিনিময়",
  "🍛": "কারি চাল",
  "🍮": "কাস্টার্ড",
  "🛃": "রীতিনীতি",
  "🌀": "ঘূর্ণিঝড়",
  "🗡": "খঞ্জক",
  "🍡": "ডাঙ্গো",
  "💨": "দূরে দূরে",
  "🌳": "পাতলা গাছ",
  "🦌": "হরিণ",
  "🚚": "ডেলিভারি ট্রাক",
  "🏬": "ডিপার্টমেন্ট স্টোর",
  "🏚": "অবরুদ্ধ বাড়ি",
  "🏜": "মরুভূমি",
  "🏝": "মরুভূমি দ্বীপ",
  "🖥": "ডেস্কটপ কম্পিউটার",
  "🕵": "গোয়েন্দা",
  "🕵 🏿": "গোয়েন্দা",
  "🕵 🏻": "গোয়েন্দা",
  "🕵 🏾": "গোয়েন্দা",
  "🕵 🏼": "গোয়েন্দা",
  "🕵 🏽": "গোয়েন্দা",
  "♦": "হীরা স্যুট",
  "💠": "একটি ডট সঙ্গে হীরা",
  "🔅": "ডিমে বোতাম",
  "🎯": "সরাসরি আঘাত",
  "😥": "হতাশ কিন্তু স্বস্তিযুক্ত মুখ",
  "😞": "হতাশ মুখ",
  "💫": "চঞ্চল",
  "😵": "চঞ্চল চেহারা",
  "🐕": "কুকুর",
  "🐶": "কুকুর মুখ",
  "💵": "ডলার নোট",
  "🐬": "ডলফিন",
  "🚪": "দরজা",
  "🔯": "বিন্দু ছয় পয়েন্ট তারকা",
  "➿": "ডাবল কোঁকড়া লুপ",
  "‼": "ডাবল উদ্দীপনা চিহ্ন",
  "🍩": "ডোনাট",
  "🕊": "ঘুঘু",
  "↙": "নীচে বাম তীর",
  "↘": "নীচে ডান তীর",
  "⬇": "নিম্নমুখী তীর",
  "🔽": "ডাউন বোতাম",
  "🐉": "ড্রাগন",
  "🐲": "ড্রাগন চেহারা",
  "👗": "পোশাক",
  "🤤": "মুখমণ্ডল",
  "💧": "ফোঁটা",
  "🥁": "ড্রাম",
  "🦆": "হাঁস",
  "📀": "ডিভিডি",
  "📧": "ই মেইল",
  "👂": "কান",
  "👂 🏿": "কান",
  "👂 🏻": "কান",
  "👂 🏾": "কান",
  "👂 🏼": "কান",
  "👂 🏽": "কান",
  "🌽": "ভূট্টা কান",
  "🥚": "ডিম",
  "🍆": "বেগুন",
  "✴": "আট পয়েন্ট তারকা",
  "✳": "আটটি ঝকঝকে তারকা",
  "🕣": "আটশ ত্রিশ",
  "🕗": "আটটা বাজে",
  "⏏": "উত্সাহিত বোতাম",
  "🔌": "বৈদ্যুতিক চাবি",
  "🐘": "হাতি",
  "🕦": "এগারো ত্রিশ",
  "🕚": "এগারোটা বাজে",
  "✉": "খাম",
  "📩": "তীরযুক্ত খাম",
  "💶": "ইউরো নোট",
  "🌲": "চিরসবুজ বৃক্ষ",
  "❗": "বিস্ময়বোধক চিহ্ন",
  "⁉": "বিস্ময়কর প্রশ্ন চিহ্ন",
  "😑": "অভিব্যক্তিহীন চেহারা",
  "👁": "চক্ষু",
  "👁 ️ ‍ 🗨 ️": "স্পিচ বুদ্বুদ চোখ",
  "👀": "চোখ",
  "😘": "একটি চুম্বন ফুঁড়ে মুখ",
  "😋": "সুস্বাদু খাবার সাভারিং চেহারা",
  "😱": "ভয়ে চিৎকার চেঁচামেচি",
  "😓": "ঠান্ডা ঘাম সঙ্গে মুখ",
  "🤕": "মাথা ব্যান্ডেজ সঙ্গে মুখ",
  "😷": "মেডিকেল মাস্কের মুখোমুখি",
  "😮": "খোলা মুখ দিয়ে মুখ",
  "😰": "খোলা মুখ ঠান্ডা ঘাম সঙ্গে মুখ",
  "🙄": "ঘূর্ণায়মান চোখের সাথে মুখ",
  "😤": "নাক থেকে বাষ্প সঙ্গে মুখ",
  "😛": "আটকে জিহ্বা দিয়ে মুখ",
  "😝": "মুখ বন্ধ জিভ বন্ধ চোখের সাথে",
  "😜": "চোখ আটকে জিহ্বা দিয়ে মুখ",
  "😂": "আনন্দের অশ্রু সহ মুখ",
  "🤒": "থার্মোমিটারের মুখোমুখি",
  "😶": "মুখ ছাড়া মুখ",
  "🏭": "কারখানা",
  "🍂": "পতিত পাতা",
  "👪": "পরিবার",
  "👨 ‍ 👦": "পরিবারের লোক ছেলে",
  "👨 ‍ 👦 ‍ 👦": "পরিবারের লোক ছেলে ছেলে",
  "👨 ‍ 👧": "পরিবার পুরুষ মেয়ে",
  "👨 ‍ 👧 ‍ 👦": "পরিবার পুরুষ মেয়ে ছেলে",
  "👨 ‍ 👧 ‍ 👧": "পরিবার পুরুষ মেয়ে মেয়ে",
  "👨 ‍ 👨 ‍ 👦": "পরিবার মানুষ ছেলে",
  "👨 ‍ 👨 ‍ 👦 ‍ 👦": "পরিবার মানুষ ছেলে ছেলে",
  "👨 ‍ 👨 ‍ 👧": "পরিবার পুরুষ মানুষ মেয়ে",
  "👨 ‍ 👨 ‍ 👧 ‍ 👦": "পরিবার পুরুষ মানুষ মেয়ে ছেলে",
  "👨 ‍ 👨 ‍ 👧 ‍ 👧": "পরিবার পুরুষ মানুষ মেয়ে মেয়ে",
  "👨 ‍ 👩 ‍ 👦": "পরিবার পুরুষ মহিলা ছেলে",
  "👨 ‍ 👩 ‍ 👦 ‍ 👦": "পরিবার পুরুষ মহিলা ছেলে ছেলে",
  "👨 ‍ 👩 ‍ 👧": "পরিবারের পুরুষ মহিলা মেয়ে",
  "👨 ‍ 👩 ‍ 👧 ‍ 👦": "পরিবার পুরুষ মহিলা মেয়ে ছেলে",
  "👨 ‍ 👩 ‍ 👧 ‍ 👧": "পরিবার পুরুষ মহিলা মেয়ে মেয়ে",
  "👩 ‍ 👦": "পরিবার মহিলা ছেলে",
  "👩 ‍ 👦 ‍ 👦": "পরিবার মহিলা ছেলে ছেলে",
  "👩 ‍ 👧": "পরিবারের মহিলা মেয়ে",
  "👩 ‍ 👧 ‍ 👦": "পরিবার মহিলা মেয়ে ছেলে",
  "👩 ‍ 👧 ‍ 👧": "পরিবার মহিলা মেয়ে মেয়ে",
  "👩 ‍ 👩 ‍ 👦": "পরিবার মহিলা মহিলা ছেলে",
  "👩 ‍ 👩 ‍ 👦 ‍ 👦": "পরিবার মহিলা মহিলা ছেলে ছেলে",
  "👩 ‍ 👩 ‍ 👧": "পরিবার মহিলা মহিলা মেয়ে",
  "👩 ‍ 👩 ‍ 👧 ‍ 👦": "পরিবার মহিলা মহিলা মেয়ে ছেলে",
  "👩 ‍ 👩 ‍ 👧 ‍ 👧": "পরিবার মহিলা মহিলা মেয়ে মেয়ে",
  "⏩": "দ্রুত ফরোয়ার্ড বোতাম",
  "⏬": "দ্রুত ডাউন বোতাম",
  "⏪": "দ্রুত বিপরীত বোতাম",
  "⏫": "দ্রুত আপ বোতাম",
  "📠": "ফ্যাক্স মেশিন",
  "😨": "ভীত মুখ",
  "♀": "মহিলা চিহ্ন",
  "🎡": "ফেরিস হুইল",
  "⛴": "ফেরি",
  "🏑": "হকি মাঠ",
  "🗄": "ফাইল মন্ত্রিসভা",
  "📁": "ফাইল ফোল্ডার",
  "🎞": "ফিল্ম ফ্রেম",
  "📽": "ফিল্ম প্রজেক্টর",
  "🔥": "আগুন",
  "🚒": "দমকল",
  "🎆": "আতশবাজি",
  "🌓": "প্রথম চতুর্থাংশ চাঁদ",
  "🌛": "মুখের সাথে প্রথম কোয়ার্টারের চাঁদ",
  "🐟": "মাছ",
  "🍥": "ঘূর্ণি দিয়ে মাছের পিষ্টক",
  "🎣": "বর্শি",
  "🕠": "পাঁচশত তিরিশ",
  "🕔": "পাঁচটা বাজে",
  "⛳": "গর্তে পতাকা",
  "🔦": "টর্চলাইট",
  "⚜": "ফ্লেয়ার ডি লিস",
  "💪": "ফ্লেক্সড বাইসপস",
  "💪 🏿": "ফ্লেক্সড বাইসপস",
  "💪 🏻": "ফ্লেক্সড বাইসপস",
  "💪 🏾": "ফ্লেক্সড বাইসপস",
  "💪 🏼": "ফ্লেক্সড বাইসপস",
  "💪 🏽": "ফ্লেক্সড বাইসপস",
  "💾": "ফ্লপি ডিস্ক",
  "🎴": "ফুল বাজানো কার্ড",
  "😳": "রাঙা মুখ",
  "🌫": "কুয়াশা",
  "🌁": "কুয়াশাচ্ছন্ন",
  "🙏": "ভাঁজ করা হাত",
  "🙏 🏿": "ভাঁজ করা হাত",
  "🙏 🏻": "ভাঁজ করা হাত",
  "🙏 🏾": "ভাঁজ করা হাত",
  "🙏 🏼": "ভাঁজ করা হাত",
  "🙏 🏽": "ভাঁজ করা হাত",
  "👣": "পায়ের ছাপ",
  "🍴": "কাঁটাচামচ এবং ছুরি",
  "🍽": "প্লেট দিয়ে কাঁটাচামচ এবং ছুরি",
  "⛲": "ঝর্ণা",
  "🖋": "ঝর্ণা কলম",
  "🕟": "চারশত ত্রিশ",
  "🍀": "চার পাতার ক্লোভার",
  "🕓": "চারটা বাজে",
  "🦊": "শিয়ালের মুখ",
  "🖼": "ফ্রেমযুক্ত ছবি",
  "🍟": "ফ্রেঞ্চ ফ্রাই",
  "🍤": "ভাজা চিংড়ি",
  "🐸": "ব্যাঙের মুখ",
  "🐥": "সামনে মুখ শিশুর কুক্কুট",
  "☹": "ভঙ্গুর মুখ",
  "😦": "খোলা মুখ দিয়ে ভ্রূকুটো মুখ",
  "⛽": "জ্বালানি পাম্প",
  "🌕": "পূর্ণিমা",
  "🌝": "মুখ দিয়ে পূর্ণিমা",
  "⚱": "অন্ত্যেষ্টিক্রিয়া মুরগী",
  "🎲": "খেলা মরা",
  "⚙": "গিয়ার",
  "💎": "রত্ন পাথর",
  "👻": "প্রেতাত্মা",
  "👧": "মেয়ে",
  "👧 🏿": "মেয়ে",
  "👧 🏻": "মেয়ে",
  "👧 🏾": "মেয়ে",
  "👧 🏼": "মেয়ে",
  "👧 🏽": "মেয়ে",
  "🥛": "এক গ্লাস দুধ",
  "👓": "চশমা",
  "🌎": "আমেরিকা যুক্তরাষ্ট্র দেখাচ্ছে",
  "🌏": "বিশ্ব এশিয়া অস্ট্রেলিয়া দেখাচ্ছে",
  "🌍": "ইউরোপ আফ্রিকা দেখাচ্ছে গ্লোব",
  "🌐": "মেরিডিয়ানদের সাথে গ্লোব",
  "🌟": "জ্বলন্ত নক্ষত্র",
  "🥅": "গোল নেট",
  "🐐": "ছাগল",
  "👺": "গব্লিন",
  "🦍": "গরিলা",
  "🎓": "স্নাতক ক্যাপ",
  "🍇": "আঙ্গুর",
  "🍏": "সবুজ আপেল",
  "📗": "সবুজ বই",
  "💚": "সবুজ হৃদয়",
  "🥗": "গ্রীণ সালাদ",
  "😬": "মুখোমুখি",
  "😸": "হাসি চোখে বিড়াল বিড়াল মুখ",
  "😀": "হাসি মুখ",
  "😁": "হাসি চোখে হাসি মুখ",
  "💗": "ক্রমবর্ধমান হৃদয়",
  "💂": "প্রহরী",
  "💂 🏿": "প্রহরী",
  "💂 🏻":  "রক্ষা করুন",
  "💂 🏾":  "রক্ষা করুন",
  "💂 🏼": "রক্ষা করুন",
  "💂 🏽": "রক্ষা করুন",
  "🎸": "গিটার",
  "🍔": "হ্যামবার্গার",
  "🔨": "হাতুড়ি",
  "⚒": "হাতুড়ি এবং বাছাই",
  "🛠": "হাতুড়ি এবং রেঞ্চ",
  "🐹": "হামস্টার মুখ",
  "👜": "হ্যান্ডব্যাগ",
  "🤝": "হ্যান্ডশেক",
  "🐣": "ছানা ছানা",
  "🎧": "হেডফোন",
  "🙉": "কোন মন্দ বানর শুনো না",
  "💟": "হৃদয় সজ্জা",
  "♥": "হার্ট স্যুট",
  "💘": "তীর দিয়ে হৃদয়",
  "💝": "ফিতা দিয়ে হৃদয়",
  "✔": "ভারী চেক চিহ্ন",
  "➗": "ভারী বিভাগের চিহ্ন",
  "💲": "ভারী ডলার চিহ্ন",
  "❣": "ভারী হৃদয় উদ্দীপনা",
  "⭕": "ভারী বড় বৃত্ত",
  "➖": "ভারী বিয়োগ চিহ্ন",
  "✖": "ভারী গুণ x",
  "➕": "ভারী প্লাস চিহ্ন",
  "🚁": "হেলিকপ্টার",
  "🌿": "ভেষজ",
  "🌺": "হিবিস্কাস",
  "👠": "উঁচু হিল জুতো",
  "🚄": "উচ্চ গতির ট্রেন",
  "🚅": "বুলেট নাক দিয়ে দ্রুত গতির ট্রেন",
  "⚡": "উচ্চ ভোল্টেজের",
  "🕳": "গর্ত",
  "🍯": "মধুর পাত্র",
  "🐝": "মৌমাছি",
  "🚥": "অনুভূমিক ট্র্যাফিক আলো",
  "🐎": "ঘোড়া",
  "🐴": "ঘোড়ার মুখ",
  "🏇": "ঘোড়দৌড়",
  "🏇 🏿": "ঘোড়া দৌড়",
  "🏇 🏻": "ঘোড়া দৌড়",
  "🏇 🏾": "ঘোড়া দৌড়",
  "🏇 🏼": "ঘোড়া দৌড়",
  "🏇 🏽": "ঘোড়া দৌড়",
  "🏥": "হাসপাতাল",
  "☕": "গরম পানীয়",
  "🌭": "হট ডগ",
  "🌶": "ঝাল মরিচ",
  "♨": "গরম ঝরনা",
  "🏨": "হোটেল",
  "⌛": "ঘন্টাঘড়ি",
  "⏳": "বয়ে যাওয়া বালি সঙ্গে ঘন্টাঘড়ি",
  "🏠": "গৃহ",
  "🏡": "বাগান সহ ঘর",
  "🤗": "আলিঙ্গন মুখ",
  "💯": "শত পয়েন্ট",
  "😯": "টক মুখ",
  "🍨": "আইসক্রিম",
  "🏒": "আইস হকি",
  "⛸": "বরফ স্কেইট্",
  "📥": "ইনবক্স ট্রে",
  "📨": "আগত খাম",
  "☝": "সূচক পয়েন্ট আপ",
  "ℹ": "তথ্য",
  "🔤": "ইনপুট ল্যাটিন অক্ষর",
  "🔡": "ইনপুট লাতিন লোয়ারকেস",
  "🔠": "ইনপুট ল্যাটিন বড় হাতের অক্ষর",
  "🔢": "ইনপুট নম্বর",
  "🔣": "ইনপুট প্রতীক",
  "🎃": "জ্যাক ও লণ্ঠন",
  "👖": "জিন্স",
  "🃏": "জোকার",
  "🕹": "জয়স্টিক",
  "🕋": "কাবা",
  "🔑": "চাবি",
  "⌨": "কীবোর্ড",
  "# ️ ⃣": "কীক্যাপ",
  "* ️ ⃣": "কীক্যাপ",
  "0 ️ ⃣": "কীক্যাপ 0",
  "1 ️ ⃣": "কীক্যাপ 1",
  "🔟": "কীক্যাপ 10",
  "2 ️ ⃣": "কীক্যাপ 2",
  "3 ️ ⃣": "কীক্যাপ 3",
  "4 ️ ⃣": "কীক্যাপ 4",
  "5 ️ ⃣": "কীক্যাপ 5",
  "6 ️ ⃣": "কীক্যাপ 6",
  "7 ️ ⃣": "কীক্যাপ 7",
  "8 ️ ⃣": "কীক্যাপ 8",
  "9 ️ ⃣": "কীক্যাপ 9",
  "🛴": "কিক স্কুটার",
  "👘": "কিমনো",
  "💏": "চুম্বন",
  "👨 ‍ ❤ ️ ‍ 💋 ‍ 👨": "মানুষ চুমু",
  "💋": "চুম্বন চিহ্ন",
  "👩 ‍ ❤ ️ ‍ 💋 ‍ 👨": "চুম্বন মহিলা মানুষ",
  "👩 ‍ ❤ ️ ‍ 💋 ‍ 👩": "চুম্বন মহিলা মহিলা",
  "😽": "বন্ধ চোখে বিড়াল মুখ চুম্বন",
  "😗": "চুম্বন মুখ",
  "😚": "বন্ধ চোখ দিয়ে চুম্বন মুখ",
  "😙": "হাসি চোখে মুখ চুম্বন",
  "🔪": "রান্না ঘরের ছুরি",
  "🥝": "কিউই ফল",
  "🐨": "কোয়ালা",
  "🏷": "লেবেল",
  "🐞": "ভদ্রমহিলা বিটল",
  "💻": "ল্যাপটপ কম্পিউটার",
  "🔷": "বড় নীল হীরা",
  "🔶": "বড় কমলা হীরা",
  "🌗": "গত চতুর্থাংশ চাঁদ",
  "🌜": "মুখের সাথে গত কোয়ার্টারের চাঁদ",
  "⏮": "শেষ ট্র্যাক বোতাম",
  "✝": "লাতিন ক্রস",
  "🍃": "বাতাসে পাতা ঝাপটায়",
  "📒": "খাতা",
  "🤛": "বাম মুখোমুখি",
  "🤛 🏿": "বাম মুখের মুষ্টি",
  "🤛 🏻": "বাম মুখোমুখি",
  "🤛 🏾": "বাম মুখের মুষ্টি",
  "🤛 🏼": "বাম মুখের মুষ্টি",
  "🤛 🏽": "বাম মুখমুলি",
  "🔍": "বাম নির্দেশক ম্যাগনিফাইং গ্লাস",
  "↔": "বাম ডান তীর",
  "⬅": "বাম তীর",
  "↪": "বাম তীর বাঁকানো ডানদিকে",
  "🛅": "বাম লটবহর",
  "🗨": "বাম বক্তৃতা বুদ্বুদ",
  "🍋": "লেবু",
  "🐆": "চিতা",
  "🎚": "স্তর স্লাইডার",
  "💡": "হালকা বাল্ব",
  "🚈": "হালকা রেল",
  "🔗": "লিঙ্ক",
  "🖇": "লিঙ্ক পেপারক্লিপস",
  "🦁": "সিংহ মুখ",
  "💄": "লিপস্টিক",
  "🚮": "বিন সাইন মধ্যে লিটার",
  "🦎": "টিকটিকি",
  "🔒": "লকড",
  "🔐": "চাবি দিয়ে লক করা",
  "🔏": "কলমের সাথে তালাবন্ধ",
  "🚂": "লোকোমোটিভ",
  "🍭": "ললিপপ",
  "😭": "জোরে জোরে কান্নাকাটি",
  "📢": "লাউড স্পিকার",
  "🏩": "হোটেল ভালোবাসি",
  "💌": "প্রেম পত্র",
  "🤥": "মিথ্যা মুখ",
  "🀄": "মাহজং লাল ড্রাগন",
  "♂": "পুরুষ চিহ্ন",
  "👨": "মানুষ",
  "👫": "পুরুষ এবং মহিলা হাত ধরে",
  "👨 ‍ 🎨": "মানুষ শিল্পী",
  "👨 🏿 ‍ 🎨": "মানুষ শিল্পী",
  "👨 🏻 ‍ 🎨": "মানুষ শিল্পী",
  "👨 🏾 ‍ 🎨": "মানুষ শিল্পী",
  "👨 🏼 ‍ 🎨": "মানুষ শিল্পী",
  "👨 🏽 ‍ 🎨": "মানুষ শিল্পী",
  "👨 ‍ 🚀": "মানুষ নভোচারী",
  "👨 🏿 ‍ 🚀": "মানুষ মহাকাশচারী",
  "👨 🏻 ‍ 🚀": "মানুষ নভোচারী",
  "👨 🏾 ‍ 🚀": "মানুষ মহাকাশচারী",
  "👨 🏼 ‍ 🚀": "মানুষ মহাকাশচারী",
  "👨 🏽 ‍ 🚀": "মানুষ মহাকাশচারী",
  "🚴 ‍ ♂ ️": "ম্যান বাইকিং",
  "🚴 🏿 ‍ ♂ ️":  "বাইক চালানো মানুষ",
  "🚴 🏻 ‍ ♂ ️":  "সাইকেল চালানো",
  "🚴 🏾 ‍ ♂ ️": "সাইকেল চালানো",
  "🚴 🏼 ‍ ♂ ️": "মানুষ বাইকিং",
  "🚴 🏽 ‍ ♂ ️": "মানুষ বাইকিং",
  "⛹ ️ ‍ ♂ ️": "মানুষ বাউন্স বল",
  "⛹ 🏿 ‍ ♂ ️": "মানুষ বাউন্স বল",
  "⛹ 🏻 ‍ ♂ ️": "মানুষ বাউন্স বল",
  "⛹ 🏾 ‍ ♂ ️": "মানুষ বাউন্স বল",
  "⛹ 🏼 ‍ ♂ ️": "মানুষ বাউন্স বল",
  "⛹ 🏽 ‍ ♂ ️": "মানুষ বাউন্স বল",
  "🙇 ‍ ♂ ️": "মানুষ নম",
  "🙇 🏿 ‍ ♂ ️": "ভক্তি মানুষ",
  "🙇 🏻 ‍ ♂ ️":  "নমুকু মানুষ",
  "🙇 🏾 ‍ ♂ ️": "মানুষ নম",
  "🙇 🏼 ‍ ♂ ️": "মানুষ নম",
  "🙇 🏽 ‍ ♂ ️": "মানলি নম",
  "🤸 ‍ ♂ ️": "ম্যান কারওহিলিং",
  "🤸 🏿 ‍ ♂ ️": "ম্যান কার্টহিলিং",
  "🤸 🏻 ‍ ♂ ️": "ম্যান কার্টহিলিং",
  "🤸 🏾 ‍ ♂ ️": "ম্যান কার্টহিলিং",
  "🤸 🏼 ‍ ♂ ️": "ম্যান কার্টহিলিং",
  "🤸 🏽 ‍ ♂ ️": "ম্যান কার্টহিলিং",
  "👷 ‍ ♂ ️": "মানুষ নির্মাণ শ্রমিক",
  "👷 🏿 ‍ ♂ ️": "মানুষ নির্মাণ কর্মী",
  "👷 🏻 ‍ ♂ ️": "মানুষ নির্মাণ কর্মী",
  "👷 🏾 ‍ ♂ ️": "মানুষ নির্মাণ শ্রমিক",
  "👷 🏼 ‍ ♂ ️": "মানুষ নির্মাণ শ্রমিক",
  "👷 🏽 ‍ ♂ ️": "মানুষ নির্মাণ শ্রমিক",
  "👨 ‍ 🍳": "মানুষ রান্না",
  "👨 🏿 ‍ 🍳": "মানুষ রান্না",
  "👨 🏻 ‍ 🍳": "মানুষ রান্না",
  "👨 🏾 ‍ 🍳": "মানুষ রান্না",
  "👨 🏼 ‍ 🍳": "মানুষ রান্না করুন",
  "👨 🏽 ‍ 🍳": "মানুষ রান্না",
  "🕺": "মানুষ নাচ",
  "🕺 🏿": "নেচে মানুষ",
  "🕺 🏻":  "নেচে মানুষ",
  "🕺 🏾": "মানুষ নাচ",
  "🕺 🏼": "মানুষ নাচছে",
  "🕺 🏽": "নেচে মানুষ",
  "👨 🏿": "মানুষ",
  "🕵 ️ ‍ ♂ ️": "মানুষ গোয়েন্দা",
  "🕵 🏿 ‍ ♂ ️": "মানুষ গোয়েন্দা",
  "🕵 🏻 ‍ ♂ ️": "মানুষ গোয়েন্দা",
  "🕵 🏾 ‍ ♂ ️": "মানুষ গোয়েন্দা",
  "🕵 🏼 ‍ ♂ ️": "মানুষ গোয়েন্দা",
  "🕵 🏽 ‍ ♂ ️": "মানুষ গোয়েন্দা",
  "🤦 ‍ ♂ ️": "মানুষ ফেসপামিং",
  "👨 ‍ 🏭": "ম্যান কারখানার শ্রমিক",
  "👨 🏿 ‍ 🏭": "ম্যান কারখানার কর্মী",
  "👨 🏻 ‍ 🏭": "ম্যান কারখানার কর্মী",
  "👨 🏾 ‍ 🏭": "ম্যান কারখানার কর্মী",
  "👨 🏼 ‍ 🏭": "ম্যান কারখানার কর্মী",
  "👨 🏽 ‍ 🏭": "ম্যান কারখানার কর্মী",
  "👨 ‍ 🌾": "মানুষ কৃষক",
  "👨 🏿 ‍ 🌾": "মানুষ কৃষক",
  "👨 🏻 ‍ 🌾": "মানুষ কৃষক",
  "👨 🏾 ‍ 🌾": "মানুষ কৃষক",
  "👨 🏼 ‍ 🌾": "মানুষ কৃষক",
  "👨 🏽 ‍ 🌾": "মানুষ কৃষক",
  "👨 ‍ 🚒": "মানুষ দমকলকর্মী",
  "👨 🏿 ‍ 🚒": "মানুষ অগ্নিনির্বাপক",
  "👨 🏻 ‍ 🚒": "মানুষ অগ্নিনির্বাপক",
  "👨 🏾 ‍ 🚒": "মানুষ অগ্নিনির্বাপক",
  "👨 🏼 ‍ 🚒": "মানুষ অগ্নিনির্বাপক",
  "👨 🏽 ‍ 🚒": "মানুষ অগ্নিনির্বাপক",
  "🙍 ‍ ♂ ️": "মানুষ ভ্রুকুটি করছে",
  "🙍 🏿 ‍ ♂ ️": "মানুষ",
  "🙍 🏻 ‍ ♂ ️": "মানুষ",
  "🙍 🏾 ‍ ♂ ️": "মানুষ",
  "🙍 🏼 ‍ ♂ ️": "মানুষ",
  "🙅 ‍ ♂ ️": "মানুষ ইঙ্গিত করে না",
  "🙅 🏿 ‍ ♂ ️": "লোকটি ইশারা করে",
  "🙅 🏻 ‍ ♂ ️": "ইঙ্গিত করে মানুষ",
  "🙅 🏾 ‍ ♂ ️": "মানুষ ইঙ্গিত করে কোনও",
  "🙅 🏼 ‍ ♂ ️": "মানুষ ইঙ্গিত করে কোনও",
  "🙅 🏽 ‍ ♂ ️": "মানুষ ইঙ্গিত করে",
  "🙆 ‍ ♂ ️": "লোক ইঙ্গিত করছে ঠিক আছে",
  "🙆 🏿 ‍ ♂ ️": "লোক ইশারা করে",
  "🙆 🏻 ‍ ♂ ️": "ইঙ্গিত করে মানুষ",
  "🙆 🏾 ‍ ♂ ️": "লোকটি ইঙ্গিত করছে ঠিক আছে",
  "🙆 🏼 ‍ ♂ ️": "লোকটি ইঙ্গিত করছে ওকে",
  "🙆 🏽 ‍ ♂ ️": "লোকটি ইঙ্গিত করছে",
  "💇 ‍ ♂ ️": "লোক চুল কাটাচ্ছে",
  "💇 🏿 ‍ ♂ ️": "চুল চুল কাটা",
  "💇 🏻 ‍ ♂ ️": "চুল চুল কাটা পাচ্ছে",
  "💇 🏾 ‍ ♂ ️": "চুল চুল কাটা",
  "💇 🏼 ‍ ♂ ️": "চুল চুল কাটা",
  "💇 🏽 ‍ ♂ ️": "চুল চুল",
  "💆 ‍ ♂ ️": "লোক ম্যাসেজ করছে",
  "💆 🏿 ‍ ♂ ️": "মানুষ ম্যাসেজ পেয়ে",
  "💆 🏻 ‍ ♂ ️": "মানুষ ম্যাসেজ পাচ্ছে",
  "💆 🏾 ‍ ♂ ️": "মানুষ ম্যাসেজ পাচ্ছেন",
  "💆 🏼 ‍ ♂ ️": "মানুষ ম্যাসেজ পাচ্ছেন",
  "💆 🏽 ‍ ♂ ️": "মানুষ ম্যাসেজ পাচ্ছেন",
  "🏌 ️ ‍ ♂ ️": "মানুষ গল্ফিং",
  "🏌 🏿 ‍ ♂ ️": "মানুষ গল্ফিং",
  "🏌 🏻 ‍ ♂ ️":  "গল্ফিং মানুষ",
  "🏌 🏾 ‍ ♂ ️": "মানুষ গল্ফিং",
  "🏌 🏼 ‍ ♂ ️": "গল্ফিং মানুষ",
  "🏌 🏽 ‍ ♂ ️": "গল্ফ মানুষ",
  "💂 ‍ ♂ ️": "ম্যান গার্ড",
  "👨 ‍ ⚕ ️": "মানুষ স্বাস্থ্যকর্মী",
  "👨 🏿 ‍ ⚕ ️": "মানুষ স্বাস্থ্য কর্মী",
  "👨 🏻 ‍ ⚕ ️": "মানুষ স্বাস্থ্য কর্মী",
  "👨 🏾 ‍ ⚕ ️": "মানুষ স্বাস্থ্য কর্মী",
  "👨 🏼 ‍ ⚕ ️": "মানুষ স্বাস্থ্য কর্মী",
  "👨 🏽 ‍ ⚕ ️": "ম্যান স্বাস্থ্য কর্মী",
  "🕴": "ব্যবসায় মামলা দায়ের করা মানুষ",
  "🕴 🏿": "ব্যবসায়ের মামলাতে লোক",
  "🕴 🏻": "ব্যবসায়িক মামলা ভাসানো লোক",
  "🕴 🏾": "লভ্যাটিংয়ে ব্যবসায়ের ক্ষেত্রে লোক",
  "🕴 🏼": "লভ্যাটিংয়ে ব্যবসায়ের ক্ষেত্রে লোক",
  "🕴 🏽": "ব্যবসায়ের ক্ষেত্রে লোক",
  "🤵": "টাক্সিডো মানুষ",
  "🤵 🏿": "টাক্সিডো মানুষ",
  "🤵 🏻": "টাক্সিডো মানুষ",
  "🤵 🏾": "টাক্সিডোে মানুষ",
  "🤵 🏼": "টাক্সিডো মানুষ",
  "🤵 🏽": "টাক্সিলিে মানুষ",
  "👨 ‍ ⚖ ️": "মানুষ বিচারক",
  "👨 🏿 ‍ ⚖ ️": "মানুষ বিচারক",
  "👨 🏻 ‍ ⚖ ️": "মানুষ বিচারক",
  "👨 🏾 ‍ ⚖ ️": "মানুষ বিচারক",
  "👨 🏼 ‍ ⚖ ️": "মানুষ বিচারক",
  "👨 🏽 ‍ ⚖ ️": "মানুষ বিচারক",
  "🤹 ‍ ♂ ️": "মানুষ জাগ্রত",
  "🤹 🏿 ‍ ♂ ️": "জাগ্রত মানুষ",
  "🤹 🏻 ‍ ♂ ️":  "জাগ্রত মানুষ",
  "🤹 🏾 ‍ ♂ ️":  "জাগ্রত মানুষ",
  "🤹 🏼 ‍ ♂ ️": "জাগ্রত মানুষ",
  "🤹 🏽 ‍ ♂ ️": "জাগ্রত মানুষ",
  "🏋 ️ ‍ ♂ ️": "ভার উত্তোলন",
  "🏋 🏿 ‍ ♂ ️": "মানুষ উত্তোলন ওজন",
  "🏋 🏻 ‍ ♂ ️": "তোলা লোক",
  "🏋 🏾 ‍ ♂ ️": "ভার উত্তোলন ওজন",
  "🏋 🏼 ‍ ♂ ️": "ওজন উত্তোলন",
  "🏋 🏽 ‍ ♂ ️": "ওলি উত্তোলন",
  "👨 🏻": "মানুষ",
  "👨 ‍ 🔧": "ম্যান মেকানিক",
  "👨 🏿 ‍ 🔧": "মানুষ যান্ত্রিক",
  "👨 🏻 ‍ 🔧": "ম্যান মেকানিক",
  "👨 🏾 ‍ 🔧": "ম্যান মেকানিক",
  "👨 🏼 ‍ 🔧": "ম্যান মেকানিক",
  "👨 🏽 ‍ 🔧": "ম্যান মেকানিক",
  "👨 🏾": "মানুষ",
  "👨 🏼": "মানুষ",
  "👨 🏽": "মানুষ",
  "🚵 ‍ ♂ ️": "ম্যান পর্বত বাইকিং",
  "🚵 🏿 ‍ ♂ ️": "মানুষ পর্বত সাইকেল",
  "🚵 🏻 ‍ ♂ ️": "ম্যান পর্বত বাইক চালানো",
  "🚵 🏾 ‍ ♂ ️": "মানুষ পর্বত বাইকিং",
  "🚵 🏼 ‍ ♂ ️": "ম্যান পর্বত বাইকিং",
  "🚵 🏽 ‍ ♂ ️": "মানুষ পর্বত বাইকলি",
  "👨 ‍ 💼": "মানুষ অফিস কর্মী",
  "👨 🏿 ‍ 💼": "মানুষ অফিসে কর্মী",
  "👨 🏻 ‍ 💼": "মানুষ অফিসে কর্মী",
  "👨 🏾 ‍ 💼": "ম্যান অফিস অফিসার",
  "👨 🏼 ‍ 💼": "পুরুষ অফিসে কর্মী",
  "👨 🏽 ‍ 💼": "পুরুষ অফিসে কর্মী",
  "👨 ‍ ✈ ️": "মানুষ পাইলট",
  "👨 🏿 ‍ ✈ ️": "মানুষ পাইলট",
  "👨 🏻 ‍ ✈ ️": "মানুষ পাইলট",
  "👨 🏾 ‍ ✈ ️": "মানুষ পাইলট",
  "👨 🏼 ‍ ✈ ️": "মানুষ পাইলট",
  "👨 🏽 ‍ ✈ ️": "মানুষ পাইলট",
  "🤾 ‍ ♂ ️": "লোক হ্যান্ডবল খেলছে",
  "🤾 🏿 ‍ ♂ ️": "লোকটি হ্যান্ডবল খেলছে",
  "🤾 🏻 ‍ ♂ ️": "লোকটি হ্যান্ডবল খেলছে",
  "🤾 🏾 ‍ ♂ ️": "হ্যান্ডবল খেলছেন লোক",
  "🤾 🏼 ‍ ♂ ️": "হ্যান্ডবল খেলছে লোক",
  "🤾 🏽 ‍ ♂ ️": "হ্যান্ডলি খেলছে লোক",
  "🤽 ‍ ♂ ️": "মানুষ ওয়াটার পোলো খেলছে",
  "🤽 🏿 ‍ ♂ ️": "মানুষ ওয়াটার পোলো খেলছে",
  "🤽 🏻 ‍ ♂ ️": "মানুষ ওয়াটার পোলো খেলছে",
  "🤽 🏾 ‍ ♂ ️": "মানুষ ওয়াটার পোলাও খেলছে",
  "🤽 🏼 ‍ ♂ ️": "মানুষ ওয়াটার পোলাও খেলছে",
  "🤽 🏽 ‍ ♂ ️": "মানুষ ওয়াটার পোলি খেলছে",
  "👮 ‍ ♂ ️": "পুরুষ পুলিশ কর্মকর্তা",
  "👮 🏿 ‍ ♂ ️": "লোক পুলিশ অফিসার",
  "👮 🏻 ‍ ♂ ️": "লোক পুলিশ অফিসার",
  "👮 🏾 ‍ ♂ ️": "পুলিশ আধিকারিক",
  "👮 🏼 ‍ ♂ ️": "পুলিশ আধিকারিক",
  "👮 🏽 ‍ ♂ ️": "পুলিশ অফিসার",
  "🙎 ‍ ♂ ️": "মানুষ পাউটিং",
  "🙎 🏿 ‍ ♂ ️": "মানুষ বিস্ফুরিত",
  "🙎 🏻 ‍ ♂ ️": "বিস্ফুরিত মানুষ",
  "🙎 🏾 ‍ ♂ ️": "মানুষ পাউটিং",
  "🙎 🏼 ‍ ♂ ️": "মানুষ পাউটিং করছে",
  "🙎 🏽 ‍ ♂ ️": "মানুষ পাউটিং",
  "🙋 ‍ ♂ ️": "মানুষ হাত তুলছে",
  "🙋 🏿 ‍ ♂ ️": "মানুষ হাত উত্থাপন",
  "🙋 🏻 ‍ ♂ ️": "হাত উত্থাপন",
  "🙋 🏾 ‍ ♂ ️": "মানুষ হাত উত্থাপন",
  "🙋 🏼 ‍ ♂ ️": "হাত হালকা উত্থাপন",
  "🙋 🏽 ‍ ♂ ️": "হলি উত্থাপন",
  "🚣 ‍ ♂ ️": "মানুষ নৌকা চালাচ্ছে",
  "🚣 🏿 ‍ ♂ ️": "মানুষ রোইং নৌকা",
  "🚣 🏻 ‍ ♂ ️": "ম্যান রোয়িং বোট",
  "🚣 🏾 ‍ ♂ ️": "ম্যান রোয়িং বোট",
  "🚣 🏼 ‍ ♂ ️": "ম্যান রোয়িং বোট",
  "🚣 🏽 ‍ ♂ ️": "ম্যান রোয়িং বলি",
  "🏃 ‍ ♂ ️": "দৌড়ে লোক",
  "🏃 🏿 ‍ ♂ ️": "মানুষ চলমান",
  "🏃 🏻 ‍ ♂ ️": "চলমান মানুষ",
  "🏃 🏾 ‍ ♂ ️": "মানুষ চলমান",
  "🏃 🏼 ‍ ♂ ️": "মানুষ চলমান",
  "🏃 🏽 ‍ ♂ ️": "মানলি চলমান",
  "👨 ‍ 🔬": "মানুষ বিজ্ঞানী",
  "👨 🏿 ‍ 🔬": "মানুষ বিজ্ঞানী",
  "👨 🏻 ‍ 🔬": "মানুষ বিজ্ঞানী",
  "👨 🏾 ‍ 🔬": "মানুষ বিজ্ঞানী",
  "👨 🏼 ‍ 🔬": "মানুষ বিজ্ঞানী",
  "👨 🏽 ‍ 🔬": "মানুষ বিজ্ঞানী",
  "🤷 ‍ ♂ ️": "মানুষ টানছে",
  "🤷 🏿 ‍ ♂ ️": "মানুষ টানছে",
  "🤷 🏻 ‍ ♂ ️": "মানুষ টানছে",
  "🤷 🏾 ‍ ♂ ️": "মানুষ টানছে",
  "🤷 🏼 ‍ ♂ ️": "মানুষ টানছে",
  "🤷 🏽 ‍ ♂ ️": "মানলি টানছে",
  "👨 ‍ 🎤": "মানুষ গায়ক",
  "👨 🏿 ‍ 🎤": "মানুষ গায়ক",
  "👨 🏻 ‍ 🎤": "মানুষ গায়ক",
  "👨 🏾 ‍ 🎤": "মানুষ গায়ক",
  "👨 🏼 ‍ 🎤": "মানুষ গায়ক",
  "👨 🏽 ‍ 🎤": "মানুষ গায়ক",
  "👨 ‍ 🎓": "মানুষ ছাত্র",
  "👨 🏿 ‍ 🎓": "মানুষ ছাত্র",
  "👨 🏻 ‍ 🎓": "মানুষ ছাত্র",
  "👨 🏾 ‍ 🎓": "মানুষ ছাত্র",
  "👨 🏼 ‍ 🎓": "মানুষ ছাত্র",
  "👨 🏽 ‍ 🎓": "মানুষ ছাত্র",
  "🏄 ‍ ♂ ️": "ম্যান সার্ফিং",
  "🏄 🏿 ‍ ♂ ️": "সার্ফিং ম্যান",
  "🏄 🏻 ‍ ♂ ️": "সার্ফিং ম্যান",
  "🏄 🏾 ‍ ♂ ️": "সার্ফিং ম্যান",
  "🏄 🏼 ‍ ♂ ️": "সার্ফিং ম্যান",
  "🏄 🏽 ‍ ♂ ️": "ত্বক স্বর সার্ফিং ম্যান",
  "🏊 ‍ ♂ ️": "মানুষ সাঁতার কাটছে",
  "🏊 🏿 ‍ ♂ ️": "গাড়ে মানুষ সাঁতার কাটছে",
  "🏊 🏻 ‍ ♂ ️": "মানুষ সাঁতার কাটছে",
  "🏊 🏾 ‍ ♂ ️": "মানুষ সাঁতার",
  "🏊 🏼 ‍ ♂ ️": "মানুষ সাঁতার কাটছে",
  "🏊 🏽 ‍ ♂ ️": "মানুষ সাঁতার",
  "👨 ‍ 🏫": "মানুষ শিক্ষক",
  "👨 🏿 ‍ 🏫": "মানুষ শিক্ষক",
  "👨 🏻 ‍ 🏫": "মানুষ শিক্ষক",
  "👨 🏾 ‍ 🏫": "মানুষ শিক্ষক",
  "👨 🏼 ‍ 🏫": "মানুষ শিক্ষক",
  "👨 🏽 ‍ 🏫": "মানুষ শিক্ষক",
  "👨 ‍ 💻": "মানুষ প্রযুক্তিবিদ",
  "👨 🏿 ‍ 💻": "মানুষ প্রযুক্তিবিদ",
  "👨 🏻 ‍ 💻": "মানুষ প্রযুক্তিবিদ",
  "👨 🏾 ‍ 💻": "মানুষ প্রযুক্তিবিদ",
  "👨 🏼 ‍ 💻": "ম্যান টেকনোলজিস্ট",
  "👨 🏽 ‍ 💻": "মানুষ প্রযুক্তিবিদ",
  "💁 ‍ ♂ ️": "লোক টিপিং হাত",
  "💁 🏿 ‍ ♂ ️": "লোক টিপিং হাত",
  "💁 🏻 ‍ ♂ ️": "হাত টিপছে হাত",
  "💁 🏾 ‍ ♂ ️": "মানুষ টিপিং হাত",
  "💁 🏼 ‍ ♂ ️": "হাত টিপিং ম্যান",
  "💁 🏽 ‍ ♂ ️": "হাত টিপিং ম্যান",
  "🚶 ‍ ♂ ️": "মানুষ হাঁটা",
  "🚶 🏿 ‍ ♂ ️": "মানুষ হাঁটা",
  "🚶 🏻 ‍ ♂ ️": "হাঁটা মানুষ",
  "🚶 🏾 ‍ ♂ ️": "মানুষ হাঁটা",
  "🚶 🏼 ‍ ♂ ️": "মানুষ হাঁটা",
  "🚶 🏽 ‍ ♂ ️": "মানলি হাঁটা",
  "👳 ‍ ♂ ️": "পাগড়ি পরা লোক",
  "👳 🏿 ‍ ♂ ️": "পাগড়ি পরা মানুষ",
  "👳 🏻 ‍ ♂ ️": "পাগড়ির পরা মানুষ",
  "👳 🏾 ‍ ♂ ️": "পাগড়ি পরা মানুষ",
  "👳 🏼 ‍ ♂ ️": "পাগড়ি পরা মানুষ",
  "👳 🏽 ‍ ♂ ️": "পাগডলি পরা মানুষ",
  "👲": "চাইনিজ টুপিওয়ালা লোক",
  "👲 🏿": "চাইনিজ ক্যাপযুক্ত মানুষ",
  "👲 🏻": "চাইনিজ ক্যাপযুক্ত মানুষ",
  "👲 🏾": "চাইনিজ ক্যাপযুক্ত মানুষ",
  "👲 🏼": "চাইনিজ ক্যাপযুক্ত মানুষ",
  "👲 🏽": "চাইনিজ ক্যলিযুক্ত মানুষ",
  "🕰": "উনান নিকটস্থ তাকবিশেষ ঘড়ি",
  "👞": "ম্যান জুতো",
  "🗾": "জাপানের মানচিত্র",
  "🍁": "ম্যাপেল পাতা",
  "🥋": "মার্শাল আর্ট ইউনিফর্ম",
  "🍖": "হাড়ের মাংস",
  "⚕": "চিকিত্সা প্রতীক",
  "📣": "মেগাফোন",
  "🍈": "তরমুজ",
  "📝": "মেমো",
  "👯 ‍ ♂ ️": "শশ কানের সাথে পুরুষদের পার্টি",
  "🤼 ‍ ♂ ️": "পুরুষ কুস্তি",
  "🕎": "মেনোরঃ",
  "🚹": "পুরুষদের ঘর",
  "🚇": "মেট্রো",
  "🎤": "মাইক্রোফোন",
  "🔬": "মাইক্রোস্কোপ",
  "🖕": "মধ্যমা",
  "🖕 🏿": "মাঝের আঙুলের",
  "🖕 🏻": "আঙুলের",
  "🖕 🏾": "আঙুল",
  "🖕 🏼": "আঙুল",
  "🖕 🏽": "আঙুললি",
  "🎖": "সামরিক পদক",
  "🌌": "মিল্কি উপায়",
  "🚐": "মিনিবাস",
  "🗿": "মোই",
  "📱": "মোবাইল ফোন",
  "📴": "মোবাইল ফোন বন্ধ",
  "📲": "তীর সহ মোবাইল ফোন",
  "🤑": "টাকার মুখ",
  "💰": "টাকার থলে",
  "💸": "ডানা দিয়ে টাকা",
  "🐒": "বানর",
  "🐵": "বানরের মুখ",
  "🚝": "মনোরেল",
  "🎑": "চাঁদ দেখার অনুষ্ঠান",
  "🕌": "মসজিদ",
  "🛥": "মোটর নৌকা",
  "🛵": "ভট্ভটি",
  "🏍": "মোটরসাইকেল",
  "🛣": "মোটরওয়ে",
  "🗻": "ফুজি পর্বতমালা",
  "⛰": "পর্বত",
  "🚠": "পর্বত কেবল",
  "🚞": "পর্বত রেলপথ",
  "🐁": "মাউস",
  "🐭": "মাউস মুখ",
  "👄": "মুখ",
  "🎥": "সিনেমা ক্যামেরা",
  "🍄": "মাশরুম",
  "🎹": "সংগীত কীবোর্ড",
  "🎵": "বাদ্যযন্ত্র",
  "🎶": "স্বরলিপি",
  "🎼": "বাদ্যযন্ত্র স্কোর",
  "🔇": "নিঃশব্দ স্পিকার",
  "💅": "নখ পালিশ",
  "💅 🏿": "পেরেক",
  "💅 🏻": "পেরেক পলিশ",
  "💅 🏾": "পেরেক পলিশ",
  "💅 🏼": "পেরেক পলিশ",
  "💅 🏽": "পেরেক পলিশ",
  "📛": "নামের ব্যাজ",
  "🏞": "জাতীয় উদ্যান",
  "🤢": "বমি বমি ভাব",
  "👔": "নেকটি",
  "🤓": "অদ্ভুত চেহারা",
  "😐": "নিরপেক্ষ চেহারা",
  "🌑": "নতুন চাঁদ",
  "🌚": "অমাবস্যার মুখ",
  "📰": "খবরের কাগজ",
  "⏭": "পরবর্তী ট্র্যাক বোতাম",
  "🌃": "তারা সঙ্গে রাত",
  "🕤": "নটা তিরিশ",
  "🕘": "নয়টা বাজে",
  "🚳": "কোন সাইকেল নেই",
  "⛔": "প্রবেশ নিষেধ",
  "🚯": "কোনও জঞ্জাল নেই",
  "📵": "কোনও মোবাইল ফোন নেই",
  "🔞": "আঠার বছরের নিচে কেউ নেই",
  "🚷": "কোনও পথচারী নেই",
  "🚭": "ধূমপান নিষেধ",
  "🚱": "অ জলীয় জল",
  "👃": "নাক",
  "👃 🏿": "নাক",
  "👃 🏻": "নাকের",
  "👃 🏾": "নাক",
  "👃 🏼": "নাক",
  "👃 🏽": "নাক",
  "📓": "নোটবই",
  "📔": "আলংকারিক কভার সহ নোটবুক",
  "🔩": "বাদাম এবং বল্টু",
  "🐙": "অক্টোপাস",
  "🍢": "ওডেন",
  "🏢": "অফিস ভবন",
  "👹": "ওগ্রে",
  "🛢": "তেলের ড্রাম",
  "🗝": "পুরানো চাবি",
  "👴": "বৃদ্ধ লোক",
  "👴 🏿": "বুড়ো মানুষ",
  "👴 🏻": "বৃদ্ধ লোকের",
  "👴 🏾": "বুড়ো",
  "👴 🏼": "বুড়ো",
  "👴 🏽": "বুডলি",
  "👵": "বৃদ্ধা নারী",
  "👵 🏿": "বৃদ্ধ মহিলা",
  "👵 🏻": "বৃদ্ধ মহিলা",
  "👵 🏾": "বুড়ো মহিলা",
  "👵 🏼": "বৃদ্ধ মহিলা",
  "👵 🏽": "বৃদ্ধ মহিলি",
  "🕉": "ওম",
  "🚘": "আগত অটোমোবাইল",
  "🚍": "আসন্ন বাস",
  "👊": "আগত মুষ্টি",
  "👊 🏿": "আগত মুষ্টি",
  "👊 🏻": "আগত মুষ্টি",
  "👊 🏾": "আগত মুষ্টি",
  "👊 🏼": "আগত মুষ্টি",
  "👊 🏽": "আগত মুষ্টি",
  "🚔": "পুলিশ গাড়ি আসছে",
  "🚖": "আগত ট্যাক্সি",
  "🕜": "একশত তিরিশ",
  "🕐": "এক ঘটিকা",
  "📖": "খোলা বই",
  "📂": "ফাইল ফোল্ডার খুলুন",
  "👐": "খোলা হাত",
  "👐 🏿": "খোলা হাতগুলি",
  "👐 🏻": "খোলা হাতের",
  "👐 🏾": "খোলা হাত",
  "👐 🏼": "খোলা হাত",
  "👐 🏽": "খোলা হলি",
  "📭": "নিম্ন পতাকা সহ খুলুন মেলবক্স",
  "📬": "উত্থিত পতাকা সহ খুলুন মেলবক্স",
  "💿": "অপটিক্যাল ডিস্ক",
  "📙": "কমলা বই",
  "☦": "গোঁড়া ক্রস",
  "📤": "আউটবক্স ট্রে",
  "🦉": "পেঁচা",
  "🐂": "ষাঁড়",
  "📦": "প্যাকেজ",
  "📄": "পৃষ্ঠা মুখোমুখি",
  "📃": "কার্ল সহ পৃষ্ঠা",
  "📟": "পেজার",
  "🖌": "পেইন্ট ব্রাশ",
  "🌴": "পাম গাছ",
  "🥞": "প্যানকেকস",
  "🐼": "পান্ডার মুখ",
  "📎": "পেপার ক্লিপ",
  "〽": "অংশ বিকল্প চিহ্ন",
  "🎉": "পার্টি পপার",
  "🛳": "যাত্রীবাহী জাহাজ",
  "🛂": "পাসপোর্ট নিয়ন্ত্রণ",
  "⏸": "বিরতি বোতাম",
  "🐾": "থাবার ছাপ",
  "☮": "শান্তি প্রতীক",
  "🍑": "পীচ",
  "🥜": "চিনাবাদাম",
  "🍐": "নাশপাতি",
  "🖊": "কলম",
  "✏": "পেন্সিল",
  "🐧": "পেঙ্গুইন",
  "😔": "উদ্দীপ্ত মুখ",
  "👯": "শশ কানের লোকেরা পার্টি করছিল",
  "🤼": "মানুষ কুস্তি",
  "🎭": "শিল্পকলা প্রদর্শন করা",
  "😣": "অবিরাম মুখ",
  "🚴": "ব্যক্তি বাইক চালানো",
  "🚴 🏿": "বাইক চালানো ব্যক্তি",
  "🚴 🏻": "বাইক চালানো",
  "🚴 🏾":  "ব্যক্তি বাইক চালান",
  "🚴 🏼": "ব্যক্তি বাইক চালানো",
  "🚴 🏽": "ব্যক্তি বাইক চালালি",
  "⛹": "ব্যক্তি বাউন্স বল",
  "⛹ 🏿": "ব্যক্তি",
  "⛹ 🏻": "ব্যক্তি বাড়াচ্ছে",
  "⛹ 🏾": "বল উত্সাহী ব্যক্তি",
  "⛹ 🏼": "ব্যক্তি হালকা বাড়াচ্ছেন",
  "⛹ 🏽": "বলে বাউন্স করা ব্যক্তি",
  "🙇": "ব্যক্তি নম",
  "🙇 🏿": "ধনুক ব্যক্তি",
  "🙇 🏻":  "ধনুক ব্যক্তি",
  "🙇 🏾": "ধনুক ব্যক্তি",
  "🙇 🏼": "ধনুক ব্যক্তি",
  "🙇 🏽": "ধনুক ব্যক্তি",
  "🤸": "ব্যক্তি কার্টুইলিং",
  "🤸 🏿": "কার্টওয়িলিং ব্যক্তি",
  "🤸 🏻": "ব্যক্তি কার্টহিলিং",
  "🤸 🏾": "ব্যক্তি কার্টহিলিং",
  "🤸 🏼": "ব্যক্তি কার্টহিলিং",
  "🤸 🏽": "ব্যক্তি কার্টহিললি",
  "🤦": "ব্যক্তি ফেসপামিং",
  "🤦 🏿": "মুখরিত ব্যক্তি",
  "🤦 🏻": "ব্যক্তির মুখরিত",
  "🤦 🏾": "ব্যক্তি মুখমণ্ডল",
  "🤦 🏼": "ব্যক্তি মুখমণ্ডল",
  "🤦 🏽": "ব্যক্তি মুখমণ্ডল",
  "🤺": "ব্যক্তি বেড়া",
  "🙍": "ব্যক্তি ভ্রুকুটি করা",
  "🙍 🏿": "ভ্রুকুটি করা ব্যক্তি",
  "🙍 🏻": "ভঙ্গকারী ব্যক্তি",
  "🙍 🏾": "ভরাট ব্যক্তি",
  "🙍 🏼": "ভঙ্গকারী ব্যক্তি",
  "🙍 🏽": "হ্রাসকারী ব্যক্তি",
  "🙅": "কোনও ব্যক্তি ইঙ্গিত করছেন",
  "🙅 🏿": "কোনও ইঙ্গিতকারী ব্যক্তি",
  "🙅 🏻": "ইঙ্গিতকারী ব্যক্তি",
  "🙅 🏾": "কোনও ব্যক্তি ইঙ্গিত করে",
  "🙅 🏼": "ইঙ্গিতকারী ব্যক্তি",
  "🙅 🏽": "কোনও ইঙ্গিতকারী ব্যক্তি কোলি",
  "🙆": "ব্যক্তি ইঙ্গিত করে ঠিক আছে",
  "🙆 🏿": "ব্যক্তি ইশারা করে ওকে",
  "🙆 🏻":  "ইঙ্গিতকারী ব্যক্তি",
  "🙆 🏾": "ওকে ইঙ্গিতকারী ব্যক্তি",
  "🙆 🏼": "ওকে হালকা ভঙ্গি করছে",
  "🙆 🏽": "ওলিভঙ্গি করছে",
  "💇": "চুল কাটা লোক",
  "💇 🏿": "চুল কাটা",
  "💇 🏻": "চুল কাটা পেয়ে যাওয়া ব্যক্তি",
  "💇 🏾": "চুল কাটা ব্যক্তি",
  "💇 🏼": "চুল কাটা পেয়ে যাওয়া ব্যক্তি",
  "💇 🏽": "চুল কালি পেয়ে ব্যক্তি",
  "💆": "ব্যক্তি ম্যাসেজ হচ্ছে",
  "💆 🏿": "ম্যাসেজ করছেন ব্যক্তি",
  "💆 🏻": "ম্যাসেজ পেয়ে ব্যক্তি",
  "💆 🏾": "ব্যক্তি",
  "💆 🏼": "ব্যক্তি",
  "💆 🏽": "ব্যক্তি",
  "🏌": "ব্যক্তি গল্ফিং",
  "🏌 🏿":  "গল্ফিং ব্যক্তি",
  "🏌 🏻":  "গল্ফিং ব্যক্তি",
  "🏌 🏾":  "ব্যক্তি গল্ফ করে",
  "🏌 🏼": "ব্যক্তি গল্ফ করে",
  "🏌 🏽": "ব্যক্তি গল্ফিং স্কিন টোন",
  "🛌": "বিছানায় ব্যক্তি",
  "🛌 🏿": "বিছানাে ব্যক্তি",
  "🛌 🏻": "বিছানা ব্যক্তি",
  "🛌 🏾": "বিছানাে ব্যক্তি",
  "🛌 🏼": "বিছানাে ব্যক্তি",
  "🛌 🏽": "বিছালিে ব্যক্তি",
  "🤹": "ব্যক্তি জাগল",
  "🤹 🏿":  "জাগ্রত ব্যক্তি",
  "🤹 🏻":  "জাগ্রত ব্যক্তি",
  "🤹 🏾":  "জাগ্রত ব্যক্তি",
  "🤹 🏼": "জাগল ব্যক্তি",
  "🤹 🏽": "জাগ্রত ব্যক্তি",
  "🏋": "ওজন উত্তোলন",
  "🏋 🏿": "ব্যক্তি উত্তোলন ওজন",
  "🏋 🏻": "ওজন উত্তোলন",
  "🏋 🏾": "ওজন উত্তোলন",
  "🏋 🏼": "ওজন উত্তোলন",
  "🏋 🏽": "ওলি উত্তোলন",
  "🚵": "ব্যক্তি পর্বত বাইকিং",
  "🚵 🏿": "ব্যক্তি পর্বত বাইক চালিয়ে",
  "🚵 🏻": "ব্যক্তি মাউন্টেন বাইক চালানোর",
  "🚵 🏾": "ব্যক্তি পর্বত বাইকিং",
  "🚵 🏼": "ব্যক্তি মাউন্টেন বাইকিং",
  "🚵 🏽": "ব্যক্তি মাউন্টেন বাইকলি",
  "🤾": "হ্যান্ডবল খেলছে ব্যক্তি",
  "🤾 🏿": "হ্যান্ডবল খেলছেন ব্যক্তি",
  "🤾 🏻": "হ্যান্ডবল খেলছেন ব্যক্তি",
  "🤾 🏾": "হ্যান্ডবল খেলছেন ব্যক্তি",
  "🤾 🏼": "হ্যান্ডবল খেলছেন ব্যক্তি",
  "🤾 🏽": "হ্যান্ডলি খেলছেন ব্যক্তি",
  "🤽": "ওয়াটার পোলো খেলছেন ব্যক্তি",
  "🤽 🏿": "জল পোলাও খেলছেন",
  "🤽 🏻": "ওয়াটার পোলো খেলছেন ব্যক্তি",
  "🤽 🏾": "ওয়াটার পোলো খেলছেন ব্যক্তি",
  "🤽 🏼": "ওয়াটার পোলো খেলছেন ব্যক্তি",
  "🤽 🏽": "ওয়াটার পোলি খেলছেন ব্যক্তি",
  "🙎": "ব্যক্তি পাউটিং",
  "🙎 🏿": "বিস্ফুরিত ব্যক্তি",
  "🙎 🏻":  "বিস্ফুরিত ব্যক্তি",
  "🙎 🏾": "ব্যক্তি পাউটিং",
  "🙎 🏼": "ব্যক্তি পাউটিং করছে",
  "🙎 🏽": "ত্বক স্বর পাউটিং ব্যক্তি",
  "🙋": "হাত বাড়ানো",
  "🙋 🏿": "হাত উত্থাপন ব্যক্তি",
  "🙋 🏻": "হাত উত্থাপন",
  "🙋 🏾": "হাত উত্থাপন ব্যক্তি",
  "🙋 🏼": "হাত হালকা উত্থাপনকারী",
  "🙋 🏽": "হলি উত্থাপনকারী",
  "🚣": "ব্যক্তি নৌকা চালাচ্ছে",
  "🚣 🏿": "ব্যক্তি নৌকা",
  "🚣 🏻": "ব্যক্তি নৌকা রোয়িং",
  "🚣 🏾": "ব্যক্তি নৌকা",
  "🚣 🏼": "ব্যক্তি নৌকা",
  "🚣 🏽": "ব্যক্তি নৌকা চামড়া স্বর",
  "🏃": "ব্যক্তি চলছে",
  "🏃 🏿": "চলমান ব্যক্তি",
  "🏃 🏻": "চলমান ব্যক্তি",
  "🏃 🏾": "চলমান ব্যক্তি",
  "🏃 🏼": "চলমান ব্যক্তি",
  "🏃 🏽": "চলমান ব্যক্তি",
  "🤷": "ব্যক্তি কৃপণ",
  "🤷 🏿": "ব্যক্তি সঙ্কুচিত",
  "🤷 🏻": "ব্যক্তি টানছেন",
  "🤷 🏾": "ব্যক্তি সঙ্কুচিত করে",
  "🤷 🏼": "ব্যক্তি টানছেন",
  "🤷 🏽": "ব্যক্লি সঙ্কুচিত করে",
  "🏄": "ব্যক্তি সার্ফিং",
  "🏄 🏿": "সার্ফিং ব্যক্তি",
  "🏄 🏻": "সার্ফিং ব্যক্তি",
  "🏄 🏾": "সার্ফিং ব্যক্তি",
  "🏄 🏼": "সার্ফিং ব্যক্তি",
  "🏄 🏽": "ত্বক স্বর সার্ফিং ব্যক্তি",
  "🏊": "ব্যক্তি সাঁতার",
  "🏊 🏿": "সাঁতার কাটা ব্যক্তি",
  "🏊 🏻": "ব্যক্তি সাঁতারের",
  "🏊 🏾": "ব্যক্তি সাঁতার",
  "🏊 🏼": "ব্যক্তি সাঁতার",
  "🏊 🏽": "ব্যক্তি সাঁতলি",
  "🛀": "গোসল করা ব্যক্তি",
  "🛀 🏿": "ব্যক্তি সার্ফিং করছে",
  "🛀 🏻": "গ্রহণকারী ব্যক্তি",
  "🛀 🏾": "স্নান গ্রহণ ব্যক্তি",
  "🛀 🏼": "স্নানের গ্রহণকারী ব্যক্তি",
  "🛀 🏽": "স্নানলি গ্রহণকারী ব্যক্তি",
  "💁": "হাত টিপছে",
  "💁 🏿": "লোক টিপিং হাত",
  "💁 🏻": "হাত টিপিং ব্যক্তি",
  "💁 🏾": "হাত টিপিং ব্যক্তি",
  "💁 🏼": "হাতের টিপছেন ব্যক্তি",
  "💁 🏽": "হাতলি টিপছেন ব্যক্তি",
  "🚶": "ব্যক্তি হাঁটা",
  "🚶 🏿": "হাঁটা ব্যক্তি",
  "🚶 🏻": "হাঁটা ব্যক্তি",
  "🚶 🏾": "হাঁটা ব্যক্তি",
  "🚶 🏼": "হাঁটা ব্যক্তি",
  "🚶 🏽": "হাঁটা ব্যক্তি",
  "👳": "পাগড়ী পরা ব্যক্তি",
  "👳 🏿": "পাগড়ি পরা ব্যক্তি",
  "👳 🏻": "পাগড়ী পরা ব্যক্তি",
  "👳 🏾": "পাগড়ি পরা ব্যক্তি",
  "👳 🏼": "পাগড়ি পরা ব্যক্তি",
  "👳 🏽": "পাগডলি পরা ব্যক্তি",
  "⛏": "বাছাই",
  "🐖": "শূকর",
  "🐷": "শূকর মুখ",
  "🐽": "শূকর নাক",
  "💩": "পো এর গাদা",
  "💊": "বড়ি",
  "🎍": "পাইন সজ্জা",
  "🍍": "আনারস",
  "🏓": "পিং পং",
  "🔫": "পিস্তল",
  "🍕": "পিজ্জা",
  "🛐": "উপাসনা স্থান",
  "▶": "খেলুন বোতাম",
  "⏯": "খেলুন বা বিরতি বোতাম",
  "🚓": "পুলিশ গাড়ী",
  "🚨": "পুলিশ গাড়ি আলো",
  "👮": "পুলিশ অফিসার",
  "👮 🏿": "পুলিশ আধিকারিক গাড়",
  "👮 🏻": "পুলিশ আধিকারিক",
  "👮 🏾": "পুলিশ অফিসার",
  "👮 🏼": "পুলিশ আধিকারিক",
  "👮 🏽": "পুলিশ অফিসার স্কিন টোন",
  "🐩": "পোডল",
  "🎱": "পুল 8 বল",
  "🍿": "ভুট্টার খই",
  "🏤": "ডাক ঘর",
  "📯": "ডাক শিং",
  "📮": "ডাক বাক্স",
  "🍲": "খাবারের পাত্র",
  "🚰": "পানযোগ্য পানি",
  "🥔": "আলু",
  "🍗": "পোল্ট্রি লেগ",
  "💷": "পাউন্ড নোট",
  "😾": "বিড়াল মুখ বিস্ফুরিত",
  "😡": "চেহারার মুখ",
  "📿": "জপমালা",
  "🤰": "গর্ভবতী মহিলা",
  "🤰 🏿": "গর্ভবতী মহিলা",
  "🤰 🏻": "গর্ভবতী মহিলা",
  "🤰 🏾": "গর্ভবতী মহিলা",
  "🤰 🏼": "গর্ভবতী মহিলা",
  "🤰 🏽": "গর্ভবতী মহিলি",
  "🤴": "রাজপুত্র",
  "🤴 🏿": "যুবরাজ",
  "🤴 🏻": "যুবরাজ",
  "🤴 🏾": "যুবরাজ",
  "🤴 🏼": "যুবরাজ",
  "🤴 🏽": "যুবরলি",
  "👸": "রাজকুমারী",
  "👸 🏿": "রাজকন্যা",
  "👸 🏻": "রাজকন্যা",
  "👸 🏾": "রাজকন্যা",
  "👸 🏼": "রাজকন্যা",
  "👸 🏽": "রাজকন্যা",
  "🖨": "প্রিন্টার",
  "🚫": "নিষিদ্ধ",
  "💜": "বেগুনি হার্ট",
  "👛": "পার্স",
  "📌": "পুশপিন",
  "❓": "প্রশ্নবোধক",
  "🐇": "খরগোশ",
  "🐰": "খরগোশের চেহারা",
  "🏎": "রেসিং গাড়ি",
  "📻": "রেডিও",
  "🔘": "রেডিও বোতাম",
  "☢": "তেজস্ক্রিয়",
  "🚃": "রেল গাড়ি",
  "🛤": "মালবাহী রেল",
  "🌈": "রংধনু",
  "🏳 ️ ‍ 🌈": "রংধনু পতাকা",
  "🤚": "হাত পিছনে উত্থিত",
  "🤚 🏿": "হাত পিছনে উত্থাপিত",
  "🤚 🏻": "হাত পিছনে উত্থাপিত",
  "🤚 🏾": "হাত উত্থিত",
  "🤚 🏼": "হাত পিছনে উত্থাপিত",
  "🤚 🏽": "হলি পিছনে উত্থাপিত",
  "✊": "উত্থিত মুষ্টি",
  "✊ 🏿": "মুষ্টি উত্থিত",
  "✊ 🏻": "উত্থিত",
  "✊ 🏾": "উত্থিত মুষ্টি",
  "✊ 🏼": "উত্থিত মুষ্টি",
  "✊ 🏽": "উত্থিত মুষ্লি",
  "✋": "হাত তোলা",
  "✋ 🏿": "হাত",
  "✋ 🏻": "হাত উত্থিত",
  "✋ 🏾": "উত্থিত হাত",
  "✋ 🏼": "উত্থিত হাত",
  "✋ 🏽": "উত্থিত হাত",
  "🖐": "হাত বাড়িয়ে আঙ্গুল দিয়ে",
  "🖐 🏿": "আঙ্গুল দিয়ে হাত উত্থিত",
  "🖐 🏻": "আঙ্গুলের সাহায্যে উত্থিত স্প্লাইড করে",
  "🖐 🏾": "আঙ্গুলের সাহায্যে উত্থিত হাতযুক্ত",
  "🖐 🏼": "আঙ্গুলের সাহায্যে উত্থিত হাত স্প্ল্যাড করে",
  "🖐 🏽": "আঙ্গুলের সাহায্যে উত্থিত হাত",
  "🙌": "হাত তোলা",
  "🙌 🏿": "হাত বাড়িয়ে",
  "🙌 🏻": "হাত উত্থাপন",
  "🙌 🏾": "হাত উত্থাপন",
  "🙌 🏼": "হাত উত্থাপন",
  "🙌 🏽": "হলি উত্থাপন",
  "🐏": "র্যাম",
  "🐀": "ইঁদুর",
  "⏺": "রেকর্ড বোতাম",
  "♻": "পুনর্ব্যবহারযোগ্য প্রতীক",
  "🍎": "লাল আপেল",
  "🔴": "লাল বৃত্ত",
  "❤": "লাল হৃদয়",
  "🏮": "লাল কাগজের লণ্ঠন",
  "🔻": "লাল ত্রিভুজ নীচে নির্দেশিত",
  "🔺": "লাল ত্রিভুজ পয়েন্ট আপ",
  "®": "নিবন্ধিত",
  "😌": "স্বস্তিযুক্ত মুখ",
  "🎗": "অনুস্মারক ফিতা",
  "🔁": "পুনরাবৃত্তি বোতাম",
  "🔂": "পুনরায় একক বোতাম",
  "⛑": "উদ্ধারকর্মীদের হেলমেট",
  "🚻": "পায়খানা",
  "◀": "বিপরীত বোতাম",
  "💞": "ঘূর্ণায়মান হৃদয়",
  "🦏": "গণ্ডার",
  "🎀": "ফিতা",
  "🍙": "ভাতের বল",
  "🍘": "ভাত ক্র্যাকার",
  "🤜": "ডান মুখের মুষ্টি",
  "🤜 🏿": "ডান মুখের মুষ্টি",
  "🤜 🏻": "ডান মুখের মুষ্টি",
  "🤜 🏾": "ডান মুখোমুখি মুষ্টি",
  "🤜 🏼": "ডান মুখোমুখি মুষ্টি",
  "🤜 🏽": "ডান মুখের মুষ্টি",
  "🔎": "ডান পয়েন্টিং ম্যাগনিফাইং গ্লাস",
  "🗯": "ডান রাগ বুদ্বুদ",
  "➡": "সঠিক তীর",
  "⤵": "ডান তীর নিচে বাঁকানো",
  "↩": "ডান তীর বাঁকানো বাম",
  "⤴": "ডান তীর বাঁকানো",
  "💍": "রিং",
  "🍠": "ভাজা মিষ্টি আলু",
  "🤖": "রোবট মুখ",
  "🚀": "রকেট",
  "🗞": "রোলড আপ পত্রিকা",
  "🎢": "রোলার কোস্টার",
  "🤣": "হাসতে হাসতে মেঝে উপর ঘূর্ণায়মান",
  "🐓": "মোরগ",
  "🌹": "গোলাপ",
  "🏵": "গোলাপী",
  "📍": "বৃত্তাকার পুশপিন",
  "🏉": "রাগবি ফুটবল",
  "🎽": "চলমান শার্ট",
  "👟": "চলমান জুতো",
  "⛵": "নাবিক",
  "🍶": "জন্য",
  "🛰": "উপগ্রহ",
  "📡": "স্যাটেলাইট অ্যান্টেনা",
  "🎷": "স্যাক্সোফোন",
  "🏫": "বিদ্যালয়",
  "🎒": "স্কুল ব্যাকপ্যাক",
  "✂": "কাঁচি",
  "🦂": "বিচ্ছু",
  "📜": "স্ক্রোল",
  "💺": "আসন",
  "🙈": "কোন খারাপ বানর দেখতে পাবে না",
  "🌱": "চারা",
  "🤳": "সেলফি",
  "🤳 🏿": "সেলফি",
  "🤳 🏻": "সেলফি",
  "🤳 🏾": "সেলফি",
  "🤳 🏼": "সেলফি",
  "🤳 🏽": "সেলফি",
  "🕢": "সাতটা তিরিশ",
  "🕖": "সাতটা বাজে",
  "🥘": "খাবারের অগভীর প্যান",
  "☘": "ঝাঁকুনি",
  "🦈": "হাঙর",
  "🍧": "চাঁচা বরফ",
  "🌾": "ভাত",
  "🐑": "ভেড়া",
  "🛡": ".াল",
  "⛩": "শিন্টো মাজার",
  "🚢": "জাহাজ",
  "🌠": "উল্কা",
  "🛍": "কেনাকাটার থলে",
  "🛒": "বাজারের ব্যাগ",
  "🍰": "শর্টকেক",
  "🚿": "ঝরনা",
  "🦐": "চিংড়ি",
  "🔀": "ট্র্যাক বোতাম পরিবর্তন করুন",
  "🤘": "শিং এর চিহ্ন",
  "🤘 🏿": "শিঙা চিহ্ন",
  "🤘 🏻": "শিং চিহ্ন",
  "🤘 🏾": "শিঙা চিহ্ন",
  "🤘 🏼": "শিঙা চিহ্ন",
  "🤘 🏽": "শিংগুললিটির চিহ্ন",
  "🕡": "ছয় তিরিশ",
  "🕕": "ছয়টা বাজে",
  "⛷": "স্কাইয়ার",
  "🎿": "স্কিস",
  "💀": "খুলি",
  "☠": "মাথার খুলি এবং ক্রসবোনগুলি",
  "😴": "ঘুমন্ত মুখ",
  "😪": "নিদ্রাহীন মুখ",
  "🙁": "সামান্য ভীতু চেহারা",
  "🙂": "সামান্য হাসি মুখ",
  "🎰": "স্লট মেশিন",
  "🛩": "ছোট বিমান",
  "🔹": "ছোট নীল হীরা",
  "🔸": "ছোট কমলা হীরা",
  "😻": "হৃদয় চোখে হাসি বিড়াল মুখ মন্ডল",
  "😺": "খোলা মুখে হাসি বিড়াল মুখ মন্ডল",
  "☺": "হাস্যোজ্জ্বল মুখ",
  "😇": "হলোর সাথে হাসি মুখ",
  "😍": "হৃদয় চোখে হাসি মুখ",
  "😈": "শিং সঙ্গে হাসি মুখ",
  "😃": "খোলা মুখে হাসি মুখ",
  "😆": "খোলা মুখ বন্ধ চোখের হাসি মুখ",
  "😅": "খোলা মুখে শীতল ঘামের সাথে হাসি মুখ",
  "😄": "খোলা মুখে হাসি চোখে হাসি মুখ",
  "😊": "হাসি চোখে হাসি মুখ",
  "😎": "সানগ্লাসের সাথে হাসি মুখ",
  "😏": "হাসি মুখ মন্ডল",
  "🐌": "শামুক",
  "🐍": "সাপ",
  "🤧": "হাঁচি দেওয়া মুখ",
  "🏔": "বরফ পর্বত",
  "🏂": "স্নোবোর্ডার",
  "🏂 🏿": "স্নোবোর্ডার",
  "🏂 🏻": "তুষারবোর্ড",
  "🏂 🏾": "স্নোবোর্ডার",
  "🏂 🏼": "তুষারবোর্ড হালকা ত্বক",
  "🏂 🏽": "স্নোবোর্ডলি",
  "❄": "স্নোফ্লেক",
  "☃": "স্নোম্যান",
  "⛄": "বরফ ছাড়া তুষারমানব",
  "⚽": "ফুটবল বল",
  "🍦": "নরম আইসক্রিম",
  "♠": "কোদাল মামলা",
  "🍝": "স্প্যাগেটি",
  "❇": "ঝলমলে",
  "🎇": "ঝকঝকে",
  "✨": "ঝকঝকে",
  "💖": "ঝকঝকে হৃদয়",
  "🙊": "কোন খারাপ বানর কথা বলো না",
  "🔊": "স্পিকার উচ্চ পরিমাণ",
  "🔈": "স্পিকার কম ভলিউম",
  "🔉": "স্পিকার ভলিউম",
  "🗣": "কথা বলার মাথা",
  "💬": "বক্তৃতা বেলুন",
  "🚤": "স্পিডবোট",
  "🕷": "মাকড়সা",
  "🕸": "মাকড়সার জাল",
  "🗓": "সর্পিল ক্যালেন্ডার",
  "🗒": "সর্পিল নোটপ্যাড",
  "🐚": "সর্পিল শেল",
  "🥄": "চামচ",
  "🚙": "ক্রীড়া ইউটিলিটি যান",
  "🏅": "ক্রীড়া পদক",
  "🐳": "ফোঁটা তিমি",
  "🦑": "স্কুইড",
  "🏟": "স্টেডিয়াম",
  "☪": "তারা এবং ক্রিসেন্ট",
  "✡": "ডেভিডের নক্ষত্র",
  "🚉": "স্টেশন",
  "🍜": "বাষ্প বাটি",
  "⏹": "স্টপ বোতাম",
  "🛑": "সাইন বন্ধ",
  "⏱": "স্টপওয়াচ",
  "📏": "সরল শাসক",
  "🍓": "স্ট্রবেরি",
  "🎙": "স্টুডিও মাইক্রোফোন",
  "🥙": "স্টাফ ফ্ল্যাটব্রেড",
  "☀": "সূর্য",
  "⛅": "মেঘের পিছনে সূর্য",
  "🌥": "বড় মেঘের পিছনে সূর্য",
  "🌦": "বৃষ্টির মেঘের পিছনে সূর্য",
  "🌤": "ছোট মেঘের পিছনে সূর্য",
  "🌞": "মুখের সাথে সূর্য",
  "🌻": "সূর্যমুখী",
  "🕶": "সানগ্লাস",
  "🌅": "সূর্যোদয়",
  "🌄": "পর্বতমালা উপর সূর্যোদয়",
  "🌇": "সূর্যাস্ত",
  "🍣": "সুশী",
  "🚟": "সাসপেনশন রেলপথ",
  "💦": "ঘাম ফোঁটা",
  "🕍": "উপাসনালয়",
  "💉": "সিরিঞ্জ",
  "👕": "টি শার্ট",
  "🌮": "টাকো",
  "🎋": "টানবটা গাছ",
  "🍊": "ট্যানগারাইন",
  "🚕": "ট্যাক্সি",
  "🍵": "হ্যান্ডেল ছাড়াই টিচারআপ",
  "📆": "ক্যালেন্ডার ছিঁড়ে",
  "☎": "টেলিফোন",
  "📞": "টেলিফোন রিসিভার",
  "🔭": "দূরবীণ",
  "📺": "টেলিভিশন",
  "🕥": "দশটা ত্রিশ",
  "🕙": "দশটা বাজে",
  "🎾": "টেনিস",
  "⛺": "তাঁবু",
  "🌡": "থার্মোমিটার",
  "🤔": "চিন্তা ভাবনা",
  "💭": "চিন্তা বেলুন",
  "🕞": "তিন ত্রিশ",
  "🕒": "তিনটা বাজে",
  "👎": "হতাশা",
  "👎 🏿": "থাম্বগুলি নিচে",
  "👎 🏻": "থাম্ব নিচে",
  "👎 🏾": "থাম্বস ডাউন করে",
  "👎 🏼": "থাম্বগুলিটি নীচে",
  "👎 🏽": "থাম্বগুলি নিচে",
  "👍": "থাম্বস আপ",
  "👍 🏿": "থাম্বস আপ করে",
  "👍 🏻": "থাম্বস আপ করে",
  "👍 🏾": "থাম্বস আপ করে",
  "👍 🏼": "থাম্বস আপ করে",
  "👍 🏽": "থাম্বস আপ করে",
  "🎫": "টিকিট",
  "🐅": "বাঘ",
  "🐯": "বাঘের মুখ",
  "⏲": "টাইমার ঘড়ি",
  "😫": "ক্লান্ত মুখ",
  "🚽": "টয়লেট",
  "🍅": "টমেটো",
  "👅": "জিহ্বা",
  "🎩": "মাথার টুপি",
  "🌪": "টর্নেডো",
  "🖲": "ট্র্যাকবল",
  "🚜": "ট্র্যাক্টর",
  "™": "বাণিজ্য চিহ্ন",
  "🚆": "ট্রেন",
  "🚊": "ট্রাম",
  "🚋": "ট্রাম গাড়ি",
  "🚩": "ত্রিভুজাকার পতাকা",
  "📐": "ত্রিভুজাকার শাসক",
  "🔱": "ত্রিশূল প্রতীক",
  "🚎": "ট্রলিবাস",
  "🏆": "ট্রফি",
  "🍹": "ক্রান্তীয় পানীয়",
  "🐠": "গ্রীষ্মমন্ডলীয় মাছ",
  "🎺": "শিংগা",
  "🌷": "টিউলিপ",
  "🥃": "গ্লাস গ্লাস",
  "🦃": "তুরস্ক",
  "🐢": "কচ্ছপ",
  "🕧": "বারো ত্রিশ",
  "🕛": "বারোটা বাজে",
  "🐫": "দুটি কুমড়ো উট",
  "🕝": "দুই শত ত্রিশ",
  "💕": "দুটি হৃদয়",
  "👬": "দু'জন হাত ধরে",
  "🕑": "দুইটা বাজে",
  "👭": "দুই মহিলা হাত ধরে",
  "☂": "ছাতা",
  "⛱": "মাটিতে ছাতা",
  "☔": "বৃষ্টি ফোঁটা দিয়ে ছাতা",
  "😒": "মুখহীন",
  "🦄": "এককর্ণ মুখ",
  "🔓": "আনলক করা",
  "↕": "উপরে ডাউন তীর",
  "↖": "বাম তীর উপরে",
  "↗": "ডান তীর উপরে",
  "⬆": "উপরের তীর",
  "🔼": "আপ বোতাম",
  "🙃": "উল্টা মুখ",
  "🚦": "উল্লম্ব ট্র্যাফিক আলো",
  "📳": "কম্পন মোড",
  "✌": "বিজয় হাত",
  "✌ 🏿": "বিজয় হাত",
  "✌ 🏻": "বিজয় হাত",
  "✌ 🏾": "বিজয় হাত",
  "✌ 🏼": "বিজয় হাত",
  "✌ 🏽": "বিজয় হাত",
  "📹": "ভিডিও ক্যামেরা",
  "🎮": "ভিডিও গেম",
  "📼": "ভিডিও ক্যাসেট",
  "🎻": "বেহালা",
  "🌋": "আগ্নেয়গিরি",
  "🏐": "ভলিবল",
  "🖖": "ভ্যালকান সালাম",
  "🖖 🏿": "বিজয় চিহ্ন",
  "🖖 🏻": "বিজয় চিহ্ন",
  "🌘": "ক্রিসেন্ট চাঁদ নিখোঁজ",
  "🌖": "জিব্বাস চাঁদ নিখোঁজ",
  "⚠": "সতর্কতা",
  "🗑": "বর্জ্য",
  "⌚": "ঘড়ি",
  "🐃": "জলহস্তী",
  "🚾": "জল পায়খানা",
  "🌊": "জলের তরঙ্গ",
  "🍉": "তরমুজ",
  "👋": "হাত দোলাচ্ছে",
  "〰": "ঢেউ",
  "🌒": "ওয়াক্সিং ক্রিসেন্ট চাঁদ",
  "🌔": "মোম গিব্বাস চাঁদ",
  "🙀": "ক্লান্ত বিড়াল মুখ",
  "😩": "ক্লান্ত মুখ",
  "💒": "বিবাহ",
  "🐋": "তিমি",
  "☸": "ধর্মের চাকা",
  "♿": "হুইলচেয়ার প্রতীক",
  "⚪": "সাদা বৃত্ত",
  "❕": "সাদা বিস্মৃত চিহ্ন",
  "🏳": "সাদা পতাকা",
  "💮": "সাদা ফুল",
  "✅": "সাদা ভারী চেক চিহ্ন",
  "⬜": "সাদা বড় বর্গ",
  "◽": "সাদা ছোট বর্গক্ষেত্র",
  "◻": "সাদা বর্গ",
  "⭐": "সাদা তারা",
  "❔": "সাদা প্রশ্ন চিহ্ন",
  "▫": "সাদা ছোট বর্গ",
  "🔳": "সাদা বর্গাকার বোতাম",
  "🥀": "ফুলের ফুল",
  "🎐": "বায়ু ঐকতান",
  "🌬": "বাতাসের মুখ",
  "🍷": "সুরাপাত্র",
  "😉": "চোখ ধাঁধানো",
  "🐺": "নেকড়ে চেহারা",
  "👩": "মহিলা",
  "👩 ‍ 🎨": "মহিলা শিল্পী",
  "👩 🏿 ‍ 🎨": "মহিলা শিল্পী",
  "👩 🏻 ‍ 🎨": "মহিলা শিল্পী",
  "👩 🏾 ‍ 🎨": "মহিলা শিল্পী",
  "👩 🏼 ‍ 🎨": "মহিলা শিল্পী",
  "👩 🏽 ‍ 🎨": "মহিলা শিল্পী",
  "👩 ‍ 🚀": "মহিলা নভোচারী",
  "👩 🏿 ‍ 🚀": "মহিলা মহাকাশচারী",
  "👩 🏻 ‍ 🚀": "মহিলা মহাকাশচারী",
  "👩 🏾 ‍ 🚀": "মহিলা মহাকাশচারী",
  "👩 🏼 ‍ 🚀": "মহিলা মহাকাশচারী",
  "👩 🏽 ‍ 🚀": "মহিলা মহাকাশচালি",
  "🚴 ‍ ♀ ️": "মহিলা বাইক চালানো",
  "🚴 🏿 ‍ ♀ ️": "মহিলা বাইক চালিয়ে",
  "🚴 🏻 ‍ ♀ ️": "মহিলা বাইক চালানোর",
  "🚴 🏾 ‍ ♀ ️": "মহিলা বাইক চালানো",
  "🚴 🏼 ‍ ♀ ️": "মহিলা বাইকিং",
  "🚴 🏽 ‍ ♀ ️": "মহিলা বাইকিং",
  "⛹ ️ ‍ ♀ ️": "মহিলা বাউন্স বল",
  "🙇 ‍ ♀ ️": "মহিলা নম",
  "🙇 🏿 ‍ ♀ ️": "মহিলা",
  "🙇 🏻 ‍ ♀ ️": "মহিলা নম",
  "🙇 🏾 ‍ ♀ ️": "মহিলা",
  "🙇 🏼 ‍ ♀ ️": "মহিলা নম",
  "🙇 🏽 ‍ ♀ ️": "মহিলা নম",
  "🤸 ‍ ♀ ️": "মহিলা কার্টুইলিং",
  "🤸 🏿 ‍ ♀ ️": "মহিলা কার্টহিলিং",
  "🤸 🏻 ‍ ♀ ️": "মহিলা কার্টহিলিং",
  "🤸 🏾 ‍ ♀ ️": "মহিলা কার্টহিলিং",
  "🤸 🏼 ‍ ♀ ️": "মহিলা কার্টহিলিং",
  "🤸 🏽 ‍ ♀ ️": "মহিলা কার্টহিললি",
  "👷 ‍ ♀ ️": "মহিলা নির্মাণ শ্রমিক",
  "👷 🏿 ‍ ♀ ️": "মহিলা নির্মাণ কর্মী",
  "👷 🏻 ‍ ♀ ️": "মহিলা নির্মাণ কর্মী",
  "👷 🏾 ‍ ♀ ️": "মহিলা নির্মাণ কর্মী",
  "👷 🏼 ‍ ♀ ️": "মহিলা নির্মাণ কর্মী",
  "👷 🏽 ‍ ♀ ️": "মহিলা নির্মাণ কর্মী",
  "👩 ‍ 🍳": "মহিলা রান্না",
  "👩 🏿 ‍ 🍳": "মহিলা রান্না",
  "👩 🏻 ‍ 🍳": "মহিলা রান্না",
  "👩 🏾 ‍ 🍳": "মহিলা রান্না",
  "👩 🏼 ‍ 🍳": "মহিলা রান্না করুন",
  "👩 🏽 ‍ 🍳": "মহিলা রান্না",
  "💃": "মহিলা নাচ",
  "💃 🏿": "সুরে মহিলা নাচছে",
  "💃 🏻": "মহিলা নাচ",
  "💃 🏾": "মহিলা",
  "💃 🏼": "মহিলা নাচের",
  "💃 🏽": "মহিলা নাচের",
  "👩 🏿": "মহিলা",
  "🕵 ️ ‍ ♀ ️": "মহিলা গোয়েন্দা",
  "🕵 🏿 ‍ ♀ ️": "মহিলা গোয়েন্দা",
  "🕵 🏻 ‍ ♀ ️": "মহিলা গোয়েন্দা",
  "🕵 🏾 ‍ ♀ ️": "মহিলা গোয়েন্দা",
  "🕵 🏼 ‍ ♀ ️": "মহিলা গোয়েন্দা মিডিয়াম",
  "🕵 🏽 ‍ ♀ ️": "মহিলা গোয়েন্দা",
  "🤦 ‍ ♀ ️": "মহিলা ফেসপামিং",
  "🤦 🏿 ‍ ♀ ️": "মহিলা মুখমণ্ডল",
  "🤦 🏻 ‍ ♀ ️": "মহিলা মুখের",
  "🤦 🏾 ‍ ♀ ️": "মহিলা মুখমন্ডল",
  "🤦 🏼 ‍ ♀ ️": "মহিলা মুখমণ্ডল",
  "🤦 🏽 ‍ ♀ ️": "মহিলা মুখমণ্ডল",
  "👩 ‍ 🏭": "মহিলা কারখানার কর্মী",
  "👩 🏿 ‍ 🏭": "মহিলা কারখানার কর্মী",
  "👩 🏻 ‍ 🏭": "মহিলা কারখানার কর্মী",
  "👩 🏾 ‍ 🏭": "মহিলা কারখানার কর্মী",
  "👩 🏼 ‍ 🏭": "মহিলা কারখানার কর্মী",
  "👩 🏽 ‍ 🏭": "মহিলা কারখানার কর্লি",
  "👩 ‍ 🌾": "মহিলা কৃষক",
  "👩 🏿 ‍ 🌾": "মহিলা কৃষক",
  "👩 🏻 ‍ 🌾": "মহিলা কৃষক",
  "👩 🏾 ‍ 🌾": "মহিলা কৃষক",
  "👩 🏼 ‍ 🌾": "মহিলা কৃষক",
  "👩 🏽 ‍ 🌾": "মহিলা কৃষক",
  "👩 ‍ 🚒": "মহিলা দমকলকর্মী",
  "👩 🏿 ‍ 🚒": "মহিলা অগ্নিনির্বাপক",
  "👩 🏻 ‍ 🚒": "মহিলা অগ্নিনির্বাপক",
  "👩 🏾 ‍ 🚒": "মহিলা দমকল",
  "👩 🏼 ‍ 🚒": "মহিলা অগ্নিনির্বাপক",
  "👩 🏽 ‍ 🚒": "মহিলা দমকল ত্বক স্বর",
  "🙍 ‍ ♀ ️": "মহিলা ভ্রুকুটি করা",
  "🙍 🏿 ‍ ♀ ️": "মহিলা ভঙ্গুর",
  "🙍 🏻 ‍ ♀ ️": "মহিলা ভঙ্গুর করে",
  "🙍 🏾 ‍ ♀ ️": "মহিলা ভ্রুকুটি করা",
  "🙍 🏼 ‍ ♀ ️": "মহিলা ভ্রুকুটি করা",
  "🙍 🏽 ‍ ♀ ️": "মহিলি ভরাট",
  "🙅 ‍ ♀ ️": "মহিলা অঙ্গভঙ্গি কোন",
  "🙅 🏿 ‍ ♀ ️": "মহিলা কোনও ইঙ্গিত করে",
  "🙅 🏻 ‍ ♀ ️": "মহিলা কোনও অঙ্গভঙ্গি করছেন",
  "🙅 🏾 ‍ ♀ ️": "মহিলা অঙ্গভঙ্গি কোন",
  "🙅 🏼 ‍ ♀ ️": "মহিলা অঙ্গভঙ্গি কোন",
  "🙅 🏽 ‍ ♀ ️": "মহিলা অঙ্গভঙ্গি কোন",
  "🙆 ‍ ♀ ️": "মহিলা ইঙ্গিত করছে ঠিক আছে",
  "🙆 🏿 ‍ ♀ ️": "মহিলার ইশারা করার জন্য ওকে",
  "🙆 🏻 ‍ ♀ ️": "মহিলার ইশারা করছে ঠিক আছে",
  "🙆 🏾 ‍ ♀ ️": "মহিলার অঙ্গভঙ্গি ঠিক আছে",
  "🙆 🏼 ‍ ♀ ️": "মহিলার অঙ্গভঙ্গি ঠিক আছে",
  "🙆 🏽 ‍ ♀ ️": "মহিলা ইঙ্গিত করে ওলি",
  "💇 ‍ ♀ ️": "মহিলা চুল কাটা",
  "💇 🏿 ‍ ♀ ️": "মহিলা চুল কাটা পেয়ে",
  "💇 🏻 ‍ ♀ ️": "মহিলা চুল কাটা পাচ্ছে",
  "💇 🏾 ‍ ♀ ️": "মহিলা চুল কাটা পেয়ে",
  "💇 🏼 ‍ ♀ ️": "মহিলা চুল কাটা পেয়ে",
  "💇 🏽 ‍ ♀ ️": "মহিলা চুল কাটা পেয়ে",
  "💆 ‍ ♀ ️": "মহিলা ম্যাসেজ হচ্ছে",
  "💆 🏿 ‍ ♀ ️": "মহিলা ম্যাসেজ পেয়ে",
  "💆 🏻 ‍ ♀ ️": "মহিলা ম্যাসেজ পেয়ে",
  "💆 🏾 ‍ ♀ ️": "মহিলা পাচ্ছেন",
  "💆 🏼 ‍ ♀ ️": "মহিলা পাচ্ছেন",
  "💆 🏽 ‍ ♀ ️": "মহিলা ম্যাসেজ পেয়ে",
  "🏌 ️ ‍ ♀ ️": "মহিলা গল্ফিং",
  "🏌 🏿 ‍ ♀ ️": "মহিলা গল্ফ",
  "🏌 🏻 ‍ ♀ ️": "মহিলা গল্ফ",
  "🏌 🏾 ‍ ♀ ️": "মহিলা গল্ফিং",
  "🏌 🏼 ‍ ♀ ️": "মহিলা গল্ফিং মিডিয়াম",
  "🏌 🏽 ‍ ♀ ️": "মহিলা গল্ফিং স্কিন টোন",
  "💂 ‍ ♀ ️": "মহিলা প্রহরী",
  "💂 🏿 ‍ ♀ ️": "মহিলা রক্ষা করুন",
  "💂 🏻 ‍ ♀ ️": "মহিলা রক্ষা করুন",
  "💂 🏾 ‍ ♀ ️": "মহিলা রক্ষা",
  "💂 🏼 ‍ ♀ ️": "মহিলা রক্ষা",
  "💂 🏽 ‍ ♀ ️": "মহিলা গারলি",
  "👩 ‍ ⚕ ️": "মহিলা স্বাস্থ্যকর্মী",
  "👩 🏿 ‍ ⚕ ️": "মহিলা স্বাস্থ্য কর্মী",
  "👩 🏻 ‍ ⚕ ️": "মহিলা স্বাস্থ্যকর্মী",
  "👩 🏾 ‍ ⚕ ️": "মহিলা স্বাস্থ্যকর্মী",
  "👩 🏼 ‍ ⚕ ️": "মহিলা স্বাস্থ্যকর্মী",
  "👩 🏽 ‍ ⚕ ️": "মহিলা স্বাস্থ্যকর্লি",
  "👩 ‍ ⚖ ️": "মহিলা বিচারক",
  "👩 🏿 ‍ ⚖ ️": "মহিলা বিচারের",
  "👩 🏻 ‍ ⚖ ️": "মহিলা বিচারক",
  "👩 🏾 ‍ ⚖ ️": "মহিলা বিচারক",
  "👩 🏼 ‍ ⚖ ️": "মহিলা বিচারক",
  "👩 🏽 ‍ ⚖ ️": "মহিলা বিচারক",
  "🤹 ‍ ♀ ️": "মহিলা জাগ্রত",
  "🤹 🏿 ‍ ♀ ️": "মহিলা জাগ্রত",
  "🤹 🏻 ‍ ♀ ️": "মহিলা জাগ্রত",
  "🤹 🏾 ‍ ♀ ️": "মহিলা জাগ্রত",
  "🤹 🏼 ‍ ♀ ️": "মহিলা জাগ্রত",
  "🤹 🏽 ‍ ♀ ️": "মহিলি জাগ্রত",
  "🏋 ️ ‍ ♀ ️": "মহিলা উত্তোলন ওজন",
  "🏋 🏿 ‍ ♀ ️": "মহিলা উত্তোলন ওজন",
  "🏋 🏻 ‍ ♀ ️": "মহিলা উত্তোলন ওজন",
  "🏋 🏾 ‍ ♀ ️": "মহিলা উত্তোলন ওজন",
  "🏋 🏼 ‍ ♀ ️": "মহিলা উত্তোলন ওজন",
  "🏋 🏽 ‍ ♀ ️": "মহিলা উত্তোলন ওলি",
  "👩 🏻": "মহিলা",
  "👩 ‍ 🔧": "মহিলা মেকানিক",
  "👩 🏿 ‍ 🔧": "মহিলা মেকানিক",
  "👩 🏻 ‍ 🔧": "মহিলা মেকানিক",
  "👩 🏾 ‍ 🔧": "মহিলা মেকানিক",
  "👩 🏼 ‍ 🔧": "মহিলা মেকানিক",
  "👩 🏽 ‍ 🔧": "মহিলা মেকানিক",
  "👩 🏾": "মহিলা",
  "👩 🏼": "মহিলা",
  "👩 🏽": "মহিলা",
  "🚵 ‍ ♀ ️": "মহিলা পর্বত সাইকেল",
  "🚵 🏿 ‍ ♀ ️": "মহিলা পর্বত সাইকেল",
  "🚵 🏻 ‍ ♀ ️": "মহিলা পর্বত সাইকেল",
  "🚵 🏾 ‍ ♀ ️": "মহিলা পর্বত বাইকিং",
  "🚵 🏼 ‍ ♀ ️": "মহিলা পর্বত বাইকিং",
  "🚵 🏽 ‍ ♀ ️": "মহিলা পর্বত বাইকলি",
  "👩 ‍ 💼": "মহিলা অফিস কর্মী",
  "👩 🏿 ‍ 💼": "মহিলা অফিসে কর্মী",
  "👩 🏻 ‍ 💼": "মহিলা অফিসে কর্মী",
  "👩 🏾 ‍ 💼": "মহিলা অফিসে কর্মী",
  "👩 🏼 ‍ 💼": "মহিলা অফিসে কর্মী",
  "👩 🏽 ‍ 💼": "মহিলা অফিসে কর্মী",
  "👩 ‍ ✈ ️": "মহিলা পাইলট",
  "👩 🏿 ‍ ✈ ️": "মহিলা পাইলট",
  "👩 🏻 ‍ ✈ ️": "মহিলা পাইলট",
  "👩 🏾 ‍ ✈ ️": "মহিলা পাইলট",
  "👩 🏼 ‍ ✈ ️": "মহিলা পাইলট",
  "👩 🏽 ‍ ✈ ️": "মহিলা পাইলট",
  "🤾 ‍ ♀ ️": "মহিলা হ্যান্ডবল খেলছেন",
  "🤾 🏿 ‍ ♀ ️": "মহিলা হ্যান্ডবল খেলছে",
  "🤾 🏻 ‍ ♀ ️": "মহিলা হ্যান্ডবল খেলছে",
  "🤾 🏾 ‍ ♀ ️": "মহিলা হ্যান্ডবল খেলছে",
  "🤾 🏼 ‍ ♀ ️": "মহিলা হ্যান্ডবল খেলছেন",
  "🤾 🏽 ‍ ♀ ️": "মহিলা হ্যান্ডলি খেলছেন",
  "🤽 ‍ ♀ ️": "মহিলা ওয়াটার পোলো খেলছেন",
  "🤽 🏿 ‍ ♀ ️": "ওয়াটার পোলো খেলছেন মহিলা",
  "🤽 🏻 ‍ ♀ ️": "মহিলা ওয়াটার পোলো খেলছেন",
  "🤽 🏾 ‍ ♀ ️": "মহিলা ওয়াটার পোলাও খেলছেন",
  "🤽 🏼 ‍ ♀ ️": "মহিলা ওয়াটার পোলাও খেলছেন",
  "🤽 🏽 ‍ ♀ ️": "মহিলা ওয়াটার পোলি খেলছেন",
  "👮 ‍ ♀ ️": "মহিলা পুলিশ অফিসার",
  "👮 🏿 ‍ ♀ ️": "মহিলা পুলিশ আধিকারিক গাড়",
  "👮 🏻 ‍ ♀ ️": "মহিলা পুলিশ আধিকারিক",
  "👮 🏾 ‍ ♀ ️": "মহিলা পুলিশ আধিকারিক",
  "👮 🏼 ‍ ♀ ️": "মহিলা পুলিশ আধিকারিক",
  "👮 🏽 ‍ ♀ ️": "মহিলা পুলিশ অফিসলি",
  "🙎 ‍ ♀ ️": "মহিলা পাথর",
  "🙎 🏿 ‍ ♀ ️": "মহিলা বিস্ফুরিত",
  "🙎 🏻 ‍ ♀ ️": "মহিলা বিস্ফুরিত",
  "🙎 🏾 ‍ ♀ ️": "মহিলা পাউটিং",
  "🙎 🏼 ‍ ♀ ️": "মহিলা পাউটিং করছে",
  "🙎 🏽 ‍ ♀ ️": "মহিলি পাউটিং",
  "🙋 ‍ ♀ ️": "মহিলা হাত তোলা",
  "🙋 🏿 ‍ ♀ ️": "মহিলা হাত উত্থাপন",
  "🙋 🏻 ‍ ♀ ️": "মহিলা হাত উত্থাপন",
  "🙋 🏾 ‍ ♀ ️": "মহিলা উত্থাপন",
  "🙋 🏼 ‍ ♀ ️": "মহিলা হাত উত্থাপন",
  "🙋 🏽 ‍ ♀ ️": "মহিলা হলি উত্থাপন",
  "🚣 ‍ ♀ ️": "মহিলা নৌকা চালাচ্ছে",
  "🚣 🏿 ‍ ♀ ️": "মহিলা রোইং নৌকা",
  "🚣 🏻 ‍ ♀ ️": "মহিলা নৌকা",
  "🚣 🏾 ‍ ♀ ️": "মহিলা রোইং নৌকা",
  "🚣 🏼 ‍ ♀ ️": "মহিলা নৌকা",
  "🚣 🏽 ‍ ♀ ️": "মহিলা নৌকা চামড়া স্বর",
  "🏃 ‍ ♀ ️": "মহিলা ছুটে চলেছে",
  "🏃 🏿 ‍ ♀ ️": "মহিলা চলমান",
  "🏃 🏻 ‍ ♀ ️": "মহিলা চলমান",
  "🏃 🏾 ‍ ♀ ️": "মহিলা চলমান",
  "🏃 🏼 ‍ ♀ ️": "মহিলা চলমান",
  "🏃 🏽 ‍ ♀ ️": "মহিলা চলমান",
  "👩 ‍ 🔬": "মহিলা বিজ্ঞানী",
  "👩 🏿 ‍ 🔬": "মহিলা বিজ্ঞানী",
  "👩 🏻 ‍ 🔬": "মহিলা বিজ্ঞানী",
  "👩 🏾 ‍ 🔬": "মহিলা বিজ্ঞানী",
  "👩 🏼 ‍ 🔬": "মহিলা বিজ্ঞানী",
  "👩 🏽 ‍ 🔬": "মহিলা বিজ্ঞানী",
  "🤷 ‍ ♀ ️": "মহিলা সঙ্কুচিত",
  "🤷 🏿 ‍ ♀ ️": "মহিলা সঙ্কুচিত",
  "🤷 🏻 ‍ ♀ ️": "মহিলা টানছে",
  "🤷 🏾 ‍ ♀ ️": "মহিলা টানছে",
  "🤷 🏼 ‍ ♀ ️": "মহিলা টানছে",
  "🤷 🏽 ‍ ♀ ️": "মহিলি টানছে",
  "👩 ‍ 🎤": "মহিলা গায়ক",
  "👩 🏿 ‍ 🎤": "মহিলা গায়ক",
  "👩 🏻 ‍ 🎤": "মহিলা গায়ক",
  "👩 🏾 ‍ 🎤": "মহিলা গায়ক",
  "👩 🏼 ‍ 🎤": "মহিলা গায়ক",
  "👩 🏽 ‍ 🎤": "মহিলা গায়ক",
  "👩 ‍ 🎓": "মহিলা ছাত্র",
  "👩 🏿 ‍ 🎓": "মহিলা ছাত্র",
  "👩 🏻 ‍ 🎓": "মহিলা ছাত্র",
  "👩 🏾 ‍ 🎓": "মহিলা ছাত্র",
  "👩 🏼 ‍ 🎓": "মহিলা ছাত্র",
  "👩 🏽 ‍ 🎓": "মহিলা ছাত্র",
  "🏄 ‍ ♀ ️": "মহিলা সার্ফিং",
  "🏄 🏿 ‍ ♀ ️": "মহিলা সার্ফিং",
  "🏄 🏻 ‍ ♀ ️": "মহিলা সার্ফিং",
  "🏄 🏾 ‍ ♀ ️": "মহিলা সার্ফিং",
  "🏄 🏼 ‍ ♀ ️": "মহিলা সার্ফিং",
  "🏄 🏽 ‍ ♀ ️": "মহিলা সার্ফিং",
  "🏊 ‍ ♀ ️": "মহিলা সাঁতার কাটছে",
  "🏊 🏿 ‍ ♀ ️": "মহিলা সাঁতার কাটা",
  "🏊 🏻 ‍ ♀ ️": "মহিলা ত্বকের স্বর সাঁতার কাটা",
  "🏊 🏾 ‍ ♀ ️": "মহিলা সাঁতার",
  "🏊 🏼 ‍ ♀ ️": "মহিলা সাঁতার",
  "🏊 🏽 ‍ ♀ ️": "মহিলা সাঁতলি",
  "👩 ‍ 🏫": "মহিলা শিক্ষক",
  "👩 🏿 ‍ 🏫": "মহিলা শিক্ষক",
  "👩 🏻 ‍ 🏫": "মহিলা শিক্ষক",
  "👩 🏾 ‍ 🏫": "মহিলা শিক্ষক",
  "👩 🏼 ‍ 🏫": "মহিলা শিক্ষক",
  "👩 🏽 ‍ 🏫": "মহিলা শিক্ষক",
  "👩 ‍ 💻": "মহিলা প্রযুক্তিবিদ",
  "👩 🏿 ‍ 💻": "মহিলা প্রযুক্তিবিদ",
  "👩 🏻 ‍ 💻": "মহিলা প্রযুক্তিবিদ",
  "👩 🏾 ‍ 💻": "মহিলা প্রযুক্তিবিদ",
  "👩 🏼 ‍ 💻": "মহিলা প্রযুক্তিবিদ",
  "👩 🏽 ‍ 💻": "মহিলা প্রযুক্তিবিদ",
  "💁 ‍ ♀ ️": "মহিলা টিপিং হাত",
  "💁 🏿 ‍ ♀ ️": "মহিলা টিপিং হাত",
  "💁 🏻 ‍ ♀ ️": "মহিলা টিপিং হাত",
  "💁 🏾 ‍ ♀ ️": "মহিলা টিপিং হাত",
  "💁 🏼 ‍ ♀ ️": "মহিলা টিপিং হাত",
  "💁 🏽 ‍ ♀ ️": "মহিলা টিপিং হাত",
  "🚶 ‍ ♀ ️": "মহিলা হাঁটা",
  "🚶 🏿 ‍ ♀ ️": "মহিলা হাঁটা",
  "🚶 🏻 ‍ ♀ ️": "মহিলা হাঁটা",
  "🚶 🏾 ‍ ♀ ️": "মহিলা হাঁটা",
  "🚶 🏼 ‍ ♀ ️": "মহিলা হাঁটা",
  "🚶 🏽 ‍ ♀ ️": "মহিলি হাঁটা",
  "👳 ‍ ♀ ️": "পাগড়ি পরা মহিলা",
  "👳 🏿 ‍ ♀ ️": "পাগড়ি পরা মহিলা",
  "👳 🏻 ‍ ♀ ️": "পাগড়ি পরা মহিলা",
  "👳 🏾 ‍ ♀ ️": "পাগড়ি পরা মহিলা",
  "👳 🏼 ‍ ♀ ️": "পাগড়ি পরা মহিলা",
  "👳 🏽 ‍ ♀ ️": "পাগডলি পরা মহিলা",
  "👢": "মহিলার বুট",
  "👚": "নারী কাপড়",
  "👒": "মহিলার টুপি",
  "👡": "মহিলাদের স্যান্ডেল",
  "👯 ‍ ♀ ️": "শশ কানের সাথে মহিলাদের পার্টি",
  "🤼 ‍ ♀ ️": "মহিলা কুস্তি",
  "🚺": "মহিলাদের ঘর",
  "🗺": "বিশ্ব মানচিত্র",
  "😟": "চিন্তিত মুখ",
  "🎁": "মোড়ানো উপহার",
  "🔧": "রেঞ্চ",
  "✍": "লেখার হাত",
  "✍ 🏿": "হাত লেখার",
  "✍ 🏻": "হাত লেখার",
  "✍ 🏾": "হাত লেখার",
  "✍ 🏼": "হাত লেখার",
  "✍ 🏽": "হাতলি লেখার জন্য",
  "💛": "হলুদ হৃদয়",
  "💴": "ইয়েন নোট",
  "☯": "ইয়িন ইয়াং",
  "🤐": "জিপার মুখ",
  "🇦 🇽": "এল্যান্ড দ্বীপপুঞ্জ",
  ":‑)": "খুশি মুখ বা হাসিখুশি",
  ":)": "খুশি মুখ বা হাসিখুশি",
  ":-]": "খুশি মুখ বা হাসিখুশি",
  ":]": "খুশি মুখ বা হাসিখুশি",
  "8-)": "হাসি হাসি হাসি",
  ":o)": "হাসি হাসি হাসি",
  ":-}": "হাসি হাসি হাসি",
  ":}": "হাসি হাসি হাসি",
  ":-)": "হাসি হাসি হাসি",
  ":c)": "হাসি হাসি হাসি",
  ":^)": "হাসি হাসি হাসি",
  "=]": "হাসি হাসি হাসি",
  "=)": "হাসি হাসি হাসি",
  "B^D": "বড় হাসি হাসি বা চশমা সহ হাসি",
  ":-))": "খুব খুশি",
  ":-(": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":‑(": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":(": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":‑[": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":[": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":-||": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ">:[": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":{": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ">:(": "ভ্রষ্ট দুঃখিত রাগ বা পাউটিং করছে",
  ":'‑(": "ক্রন্দিত",
  ":'(": "ক্রন্দিত",
  ":'‑)": "সুখের অশ্রু",
  ":')": "সুখের অশ্রু",
  ":-*": "চুমু",
  ":*": "চুমু",
  ";‑)": "পলক বা স্মার্ক",
  ";)": "পলক বা স্মার্ক",
  "*-)": "পলক বা স্মার্ক",
  "*)": "পলক বা স্মার্ক",
  ";‑]": "পলক বা স্মার্ক",
  ";]": "পলক বা স্মার্ক",
  ";^)": "পলক বা স্মার্ক",
  ">:[(\\)]": "সংশয়ী বিরক্ত বিরক্তিহীন অস্বস্তি বা দ্বিধাগ্রস্ত",
  ":[(\\)]": "সংশয়ী বিরক্ত বিরক্তিহীন অস্বস্তি বা দ্বিধাগ্রস্ত",
  "=[(\\)]": "সংশয়ী বিরক্ত বিরক্তিহীন অস্বস্তি বা দ্বিধাগ্রস্ত",
  ":‑|": "সহজসরল চেহারা",
  ":|": "সহজসরল চেহারা",
  "O:‑)": "দেবদূত সাধু নাকি নির্দোষ",
  "O:)": "দেবদূত সাধু নাকি নির্দোষ",
  "0:‑)": "দেবদূত সাধু নাকি নির্দোষ",
  "0:)": "দেবদূত সাধু নাকি নির্দোষ",
  "0;^)": "দেবদূত সাধু নাকি নির্দোষ",
  ">:‑)": "মন্দ বা শয়তান",
  ">:)": "মন্দ বা শয়তান",
  "}:‑)": "মন্দ বা শয়তান",
  "}:)": "মন্দ বা শয়তান",
  "3:‑)": "মন্দ বা শয়তান",
  "3:)": "মন্দ বা শয়তান",
  ">;)": "মন্দ বা শয়তান",
  "|;‑)": "শীতল",
  "|‑O": "উদাস",
  "#‑)": "সারারাত পার্টিতে",
  "%‑)": "মাতাল বা বিভ্রান্ত",
  "%)": "মাতাল বা বিভ্রান্ত",
  "<:‑|": "ডাম্প",
  "(>_<)": "ঝামেলা",
  "(>_<)>": "ঝামেলা",
  "(';')": "বাচ্চা",
  "(^^>``": "নার্ভাস বা বিব্রত বা ঝামেলা বা লজ্জাজনক বা ঘামের ড্রপ",
  "(^_^;)": "নার্ভাস বা বিব্রত বা ঝামেলা বা লজ্জাজনক বা ঘামের ড্রপ",
  "(-_-;)": "নার্ভাস বা বিব্রত বা ঝামেলা বা লজ্জাজনক বা ঘামের ড্রপ",
  "(~_~;) (・.・;)": "নার্ভাস বা বিব্রত বা ঝামেলা বা লজ্জাজনক বা ঘামের ড্রপ",
  "(-_-)zzz": "ঘুমাচ্ছে",
  "(^_-)": "পলক",
  "((+_+))": "বিভ্রান্ত",
  "(+o+)": "বিভ্রান্ত",
  "(o|o)": "আল্ট্রাম্যান",
  "^_^": "আনন্দময়",
  "(^_^)/": "আনন্দময়",
  "(^O^)／": "আনন্দময়",
  "(^o^)／": "আনন্দময়",
  "(__)": "ক্ষমা চাওয়ার জন্য সম্মান বা দোয়েজার চিহ্ন হিসাবে কোটা",
  "_(._.)_": "ক্ষমা চাওয়ার জন্য সম্মান বা দোয়েজার চিহ্ন হিসাবে কোটা",
  "<(_ _)>": "ক্ষমা চাওয়ার জন্য সম্মান বা দোয়েজার চিহ্ন হিসাবে কোটা",
  "<m(__)m>": "ক্ষমা চাওয়ার জন্য সম্মান বা দোয়েজার চিহ্ন হিসাবে কোটা",
  "m(__)m": "ক্ষমা চাওয়ার জন্য সম্মান বা দোয়েজার চিহ্ন হিসাবে কোটা",
  "m(_ _)m": "ক্ষমা চাওয়ার জন্য সম্মান বা দোয়েজার চিহ্ন হিসাবে কোটা",
  "('_')": "দুঃখিত বা কাঁদছে",
  "(/_;)": "দুঃখিত বা কাঁদছে",
  "(T_T) (;_;)": "দুঃখিত বা কাঁদছে",
  "(;_;": "কান্নার দুঃখ",
  "(;_:)": "দুঃখিত বা কাঁদছে",
  "(;O;)": "দুঃখিত বা কাঁদছে",
  "(:_;)": "দুঃখিত বা কাঁদছে",
  "(ToT)": "দুঃখিত বা কাঁদছে",
  "Q.Q": "দুঃখিত বা কাঁদছে",
  "T.T": "দুঃখিত বা কাঁদছে",
  "(-.-)": "লজ্জা",
  "(-_-)": "লজ্জা",
  "(一一)": "লজ্জা",
  "(；一_一)": "লজ্জা",
  "(=_=)": "ক্লান্ত",
  "(=^·^=)": "বিড়াল",
  "(=^··^=)": "বিড়াল",
  "=_^= ": "বিড়াল",
  "(..)": "নতমুখ",
  "(._.)": "নতমুখ",
  "^m^": "মুখ ঢাকা মুখ দিয়ে জিগলিং করছে",
  "(・・?": "বিভ্রান্তি",
  "(?_?)": "বিভ্রান্তি",
  ">^_^<": "সাধারণ হাসি",
  "<^!^>": "সাধারণ হাসি",
  "^/^": "সাধারণ হাসি",
  "（*^_^*）": "সাধারণ হাসি",
  "(^<^) (^.^)": "সাধারণ হাসি",
  "(^^)": "সাধারণ হাসি",
  "(^.^)": "সাধারণ হাসি",
  "(^_^.)": "সাধারণ হাসি",
  "(^_^)": "সাধারণ হাসি",
  "(^J^)": "সাধারণ হাসি",
  "(*^.^*)": "সাধারণ হাসি",
  "(^—^）": "সাধারণ হাসি",
  "(#^.^#)": "সাধারণ হাসি",
  "(*^0^*)": "উত্তেজিত",
  "(*_*)": "অবাক",
  "(*_*;": "অবাক",
  "(+_+) (@_@)": "অবাক",
  "(*^^)v": "হাসিখুশি হাসি",
  "(^_^)v": "হাসিখুশি হাসি",
  "((d[-_-]b))": "হেডফোন গান শুনছে",
  "(-\"-)": "চিন্তিত",
  "(ーー;)": "চিন্তিত",
  "(^0_0^)": "চশমা",
  "(＾ｖ＾)": "খুশি",
  "(＾ｕ＾)": "খুশি",
  "(^)o(^)": "খুশি",
  "(^O^)": "খুশি",
  "(^o^)": "খুশি",
  ")^o^(": "খুশি",
  "o.O": "অবাক",
  "(o.o)": "অবাক",
  "(*￣m￣)": "অসন্তুষ্ট"
}